=== modified file 'client/drizzle.cc'
--- client/drizzle.cc	2011-08-05 19:19:22 +0000
+++ client/drizzle.cc	2011-08-07 22:41:28 +0000
@@ -1566,16 +1566,16 @@
   pager= "stdout";  // the default, if --pager wasn't given
   if (const char* tmp= getenv("PAGER"))
   {
-    if (strlen(tmp))
+    if (*tmp)
     {
       default_pager_set= 1;
       default_pager= tmp;
     }
   }
-  if (! isatty(0) || ! isatty(1))
+  if (not isatty(0) || not isatty(1))
   {
     status.setBatch(1); 
-    opt_silent=1;
+    opt_silent= 1;
   }
   else
     status.setAddToHistory(1);

=== modified file 'client/drizzledump_data.cc'
--- client/drizzledump_data.cc	2011-03-29 20:45:43 +0000
+++ client/drizzledump_data.cc	2011-08-07 20:48:33 +0000
@@ -23,7 +23,6 @@
 #include <drizzled/gettext.h>
 #include <string>
 #include <iostream>
-#include <boost/regex.hpp>
 #include <boost/unordered_set.hpp>
 #include <boost/lexical_cast.hpp>
 

=== modified file 'client/drizzledump_data.h'
--- client/drizzledump_data.h	2011-07-25 04:35:53 +0000
+++ client/drizzledump_data.h	2011-08-07 20:48:33 +0000
@@ -22,6 +22,7 @@
 #define DRIZZLE_MAX_LINE_LENGTH 1024*1024L-1025
 #include "client_priv.h"
 #include "server_detect.h"
+#include <cstdio>
 #include <string>
 #include <iosfwd>
 #include <iomanip>

=== modified file 'client/drizzledump_drizzle.cc'
--- client/drizzledump_drizzle.cc	2011-03-11 16:49:41 +0000
+++ client/drizzledump_drizzle.cc	2011-08-08 09:51:16 +0000
@@ -68,7 +68,7 @@
     else
       table->comment= "";
 
-    table->replicate= (strcmp(row[5], "1") == 0) ? true : false;
+    table->replicate= strcmp(row[5], "1") == 0;
     table->database= this;
     if ((not table->populateFields()) or (not table->populateIndexes()) or
       (not table->populateFkeys()))
@@ -126,7 +126,7 @@
       table->displayName= displayName;
       table->collate= row[1];
       table->engineName= row[2];
-      table->replicate= (strcmp(row[3], "1") == 0) ? true : false;
+      table->replicate= strcmp(row[3], "1") == 0;
       table->autoIncrement= 0;
       table->database= this;
       if ((not table->populateFields()) or (not table->populateIndexes()))

=== modified file 'client/drizzledump_mysql.cc'
--- client/drizzledump_mysql.cc	2011-07-05 18:15:41 +0000
+++ client/drizzledump_mysql.cc	2011-08-08 09:51:16 +0000
@@ -184,7 +184,7 @@
     DrizzleDumpFieldMySQL *field = new DrizzleDumpFieldMySQL(fieldName, dcon);
     /* Stop valgrind warning */
     field->convertDateTime= false;
-    field->isNull= (strcmp(row[3], "YES") == 0) ? true : false;
+    field->isNull= strcmp(row[3], "YES") == 0;
     /* Also sets collation */
     field->setType(row[1], row[8]);
     if (field->type.compare("ENUM") == 0)
@@ -203,7 +203,7 @@
       field->defaultValue= "";
     }
 
-    field->isAutoIncrement= (strcmp(row[8], "auto_increment") == 0) ? true : false;
+    field->isAutoIncrement= strcmp(row[8], "auto_increment") == 0;
     field->defaultIsNull= field->isNull;
 
     /* Seriously MySQL, why is BIT length in NUMERIC_PRECISION? */

=== modified file 'client/drizzleimport.cc'
--- client/drizzleimport.cc	2011-07-05 11:15:32 +0000
+++ client/drizzleimport.cc	2011-08-07 22:41:28 +0000
@@ -354,8 +354,6 @@
 {
 try
 {
-  int error=0;
-
   po::options_description commandline_options("Options used only in command line");
   commandline_options.add_options()
 
@@ -601,7 +599,7 @@
     }
 
     for (; *argv != NULL; argv++)
-      if ((error= write_to_table(*argv, con)))
+      if (int error= write_to_table(*argv, con))
         if (exitcode == 0)
           exitcode= error;
     db_disconnect(current_host, con);

=== modified file 'client/drizzleslap.cc'
--- client/drizzleslap.cc	2011-08-05 13:53:37 +0000
+++ client/drizzleslap.cc	2011-08-07 20:48:33 +0000
@@ -309,7 +309,6 @@
     if ((ptr->getType() == UPDATE_TYPE_REQUIRES_PREFIX) ||
         (ptr->getType() == SELECT_TYPE_REQUIRES_PREFIX))
     {
-      int length;
       uint32_t key_val;
       char buffer[HUGE_STRING_LENGTH];
 
@@ -324,13 +323,11 @@
       if (primary_keys.size())
       {
         key_val= (uint32_t)(random() % primary_keys.size());
-        const char *key;
-        key= primary_keys[key_val].c_str();
+        const char *key= primary_keys[key_val].c_str();
 
         assert(key);
 
-        length= snprintf(buffer, HUGE_STRING_LENGTH, "%.*s '%s'",
-                         (int)ptr->getLength(), ptr->getString(), key);
+        int length= snprintf(buffer, HUGE_STRING_LENGTH, "%.*s '%s'", (int)ptr->getLength(), ptr->getString(), key);
 
         if (run_query(con, &result, buffer, length))
         {
@@ -1262,7 +1259,6 @@
 process_options(void)
 {
   struct stat sbuf;
-  OptionString *sql_type;
   uint32_t sql_type_count= 0;
   ssize_t bytes_read= 0;
   
@@ -1405,7 +1401,7 @@
 
     query_statements.resize(query_statements_count);
 
-    sql_type= query_options;
+    OptionString* sql_type= query_options;
     do
     {
       if (sql_type->getString()[0] == 'r')

=== modified file 'client/drizzletest.cc'
--- client/drizzletest.cc	2011-07-14 11:58:57 +0000
+++ client/drizzletest.cc	2011-08-08 09:51:16 +0000
@@ -2790,13 +2790,12 @@
 {
   drizzle::connection_c& con= *cur_con;
   char query_buf[FN_REFLEN+128];
-  int tries= 0;
 
   if (!master_pos.file[0])
     die("Calling 'sync_with_master' without calling 'save_master_pos'");
 
-  snprintf(query_buf, sizeof(query_buf), "select master_pos_wait('%s', %ld)", master_pos.file,
-          master_pos.pos + offset);
+  snprintf(query_buf, sizeof(query_buf), "select master_pos_wait('%s', %ld)", master_pos.file, master_pos.pos + offset);
+  int tries= 0;
 
 wait_for_position:
 

=== modified file 'client/server_detect.cc'
--- client/server_detect.cc	2011-07-26 16:13:43 +0000
+++ client/server_detect.cc	2011-08-07 20:48:33 +0000
@@ -20,6 +20,7 @@
 
 #include "client_priv.h"
 
+#include <boost/regex.hpp>
 #include <iostream>
 #include <client/server_detect.h>
 

=== modified file 'client/server_detect.h'
--- client/server_detect.h	2011-07-26 16:13:43 +0000
+++ client/server_detect.h	2011-08-07 20:48:33 +0000
@@ -20,24 +20,24 @@
 
 #pragma once
 
-#include <boost/regex.hpp>
-#include <iosfwd>
+#include <string>
 
 class ServerDetect
 {
-  public:
-    enum server_type {
-      SERVER_MYSQL_FOUND,
-      SERVER_DRIZZLE_FOUND,
-      SERVER_UNKNOWN_FOUND
-    };
-
-    server_type getServerType() { return type; }
-    std::string& getServerVersion() { return version; }
-
-    ServerDetect(drizzle_con_st *connection);
-
-  private:
-    server_type type;
-    std::string version;
+public:
+  enum server_type 
+  {
+    SERVER_MYSQL_FOUND,
+    SERVER_DRIZZLE_FOUND,
+    SERVER_UNKNOWN_FOUND
+  };
+
+  server_type getServerType() const { return type; }
+  const std::string& getServerVersion() const { return version; }
+
+  ServerDetect(drizzle_con_st*);
+
+private:
+  server_type type;
+  std::string version;
 };

=== modified file 'drizzled/cursor.cc'
--- drizzled/cursor.cc	2011-08-05 10:29:23 +0000
+++ drizzled/cursor.cc	2011-08-08 12:51:19 +0000
@@ -589,27 +589,12 @@
   next_insert_id= 0;
 }
 
-void Cursor::drop_table(const char *)
+void Cursor::drop_table()
 {
   close();
 }
 
-
-/**
-  Performs checks upon the table.
-
-  @param session                thread doing CHECK Table operation
-
-  @retval
-    HA_ADMIN_OK               Successful upgrade
-  @retval
-    HA_ADMIN_NEEDS_UPGRADE    Table has structures requiring upgrade
-  @retval
-    HA_ADMIN_NEEDS_ALTER      Table has structures requiring ALTER Table
-  @retval
-    HA_ADMIN_NOT_IMPLEMENTED
-*/
-int Cursor::ha_check(Session *)
+int Cursor::ha_check(Session*)
 {
   return HA_ADMIN_OK;
 }
@@ -743,11 +728,9 @@
   @sa Cursor::discard_or_import_tablespace()
 */
 
-int
-Cursor::ha_discard_or_import_tablespace(bool discard)
+int Cursor::ha_discard_or_import_tablespace(bool discard)
 {
   setTransactionReadWrite();
-
   return discard_or_import_tablespace(discard);
 }
 
@@ -757,60 +740,58 @@
   @sa Cursor::drop_table()
 */
 
-void
-Cursor::closeMarkForDelete(const char *name)
+void Cursor::closeMarkForDelete()
 {
   setTransactionReadWrite();
-
-  return drop_table(name);
+  return drop_table();
 }
 
 int Cursor::index_next_same(unsigned char *buf, const unsigned char *key, uint32_t keylen)
 {
-  int error;
-  if (!(error=index_next(buf)))
-  {
-    ptrdiff_t ptrdiff= buf - getTable()->getInsertRecord();
-    unsigned char *save_record_0= NULL;
-    KeyInfo *key_info= NULL;
-    KeyPartInfo *key_part;
-    KeyPartInfo *key_part_end= NULL;
-
-    /*
-      key_cmp_if_same() compares table->getInsertRecord() against 'key'.
-      In parts it uses table->getInsertRecord() directly, in parts it uses
-      field objects with their local pointers into table->getInsertRecord().
-      If 'buf' is distinct from table->getInsertRecord(), we need to move
-      all record references. This is table->getInsertRecord() itself and
-      the field pointers of the fields used in this key.
-    */
-    if (ptrdiff)
-    {
-      save_record_0= getTable()->getInsertRecord();
-      getTable()->record[0]= buf;
-      key_info= getTable()->key_info + active_index;
-      key_part= key_info->key_part;
-      key_part_end= key_part + key_info->key_parts;
-      for (; key_part < key_part_end; key_part++)
-      {
-        assert(key_part->field);
-        key_part->field->move_field_offset(ptrdiff);
-      }
-    }
-
-    if (key_cmp_if_same(getTable(), key, active_index, keylen))
-    {
-      getTable()->status=STATUS_NOT_FOUND;
-      error=HA_ERR_END_OF_FILE;
-    }
-
-    /* Move back if necessary. */
-    if (ptrdiff)
-    {
-      getTable()->record[0]= save_record_0;
-      for (key_part= key_info->key_part; key_part < key_part_end; key_part++)
-        key_part->field->move_field_offset(-ptrdiff);
-    }
+  int error= index_next(buf);
+  if (error)
+    return error;
+
+  ptrdiff_t ptrdiff= buf - getTable()->getInsertRecord();
+  unsigned char *save_record_0= NULL;
+  KeyInfo *key_info= NULL;
+  KeyPartInfo *key_part;
+  KeyPartInfo *key_part_end= NULL;
+
+  /*
+  key_cmp_if_same() compares table->getInsertRecord() against 'key'.
+  In parts it uses table->getInsertRecord() directly, in parts it uses
+  field objects with their local pointers into table->getInsertRecord().
+  If 'buf' is distinct from table->getInsertRecord(), we need to move
+  all record references. This is table->getInsertRecord() itself and
+  the field pointers of the fields used in this key.
+  */
+  if (ptrdiff)
+  {
+    save_record_0= getTable()->getInsertRecord();
+    getTable()->record[0]= buf;
+    key_info= getTable()->key_info + active_index;
+    key_part= key_info->key_part;
+    key_part_end= key_part + key_info->key_parts;
+    for (; key_part < key_part_end; key_part++)
+    {
+      assert(key_part->field);
+      key_part->field->move_field_offset(ptrdiff);
+    }
+  }
+
+  if (key_cmp_if_same(getTable(), key, active_index, keylen))
+  {
+    getTable()->status=STATUS_NOT_FOUND;
+    error= HA_ERR_END_OF_FILE;
+  }
+
+  /* Move back if necessary. */
+  if (ptrdiff)
+  {
+    getTable()->record[0]= save_record_0;
+    for (key_part= key_info->key_part; key_part < key_part_end; key_part++)
+      key_part->field->move_field_offset(-ptrdiff);
   }
   return error;
 }

=== modified file 'drizzled/cursor.h'
--- drizzled/cursor.h	2011-06-23 10:02:30 +0000
+++ drizzled/cursor.h	2011-08-08 12:51:19 +0000
@@ -170,7 +170,7 @@
     get_auto_increment().
   */
   uint64_t next_insert_id;
-  uint64_t getNextInsertId()
+  uint64_t getNextInsertId() const
   {
     return next_insert_id;
   }
@@ -178,7 +178,7 @@
   /**
     Used by SHOW TABLE STATUS to get the current auto_inc from the engine
   */
-  uint64_t getAutoIncrement()
+  uint64_t getAutoIncrement() const
   {
     return stats.auto_increment_value;
   }
@@ -223,10 +223,7 @@
   int updateRecord(const unsigned char * old_data, unsigned char * new_data) __attribute__ ((warn_unused_result));
   int deleteRecord(const unsigned char * buf) __attribute__ ((warn_unused_result));
   void ha_release_auto_increment();
-
-  /** to be actually called to get 'check()' functionality*/
   int ha_check(Session*);
-
   void ha_start_bulk_insert(ha_rows rows);
   int ha_end_bulk_insert();
   int ha_delete_all_rows();
@@ -236,7 +233,7 @@
   int ha_disable_indexes(uint32_t mode);
   int ha_enable_indexes(uint32_t mode);
   int ha_discard_or_import_tablespace(bool discard);
-  void closeMarkForDelete(const char *name);
+  void closeMarkForDelete();
 
   void adjust_next_insert_id_after_explicit_value(uint64_t nr);
   int update_auto_increment();
@@ -603,7 +600,7 @@
     no new engine should ever use it). Right
     now HEAP does rely on it, so we cannot remove it.
   */
-  virtual void drop_table(const char *name);
+  virtual void drop_table();
 };
 
 extern const char *ha_row_type[];

=== modified file 'drizzled/execute.cc'
--- drizzled/execute.cc	2011-08-05 12:55:59 +0000
+++ drizzled/execute.cc	2011-08-10 17:58:23 +0000
@@ -35,12 +35,7 @@
 {
 }
 
-void Execute::run(const char *arg, size_t length)
-{
-  run(std::string(arg, length));
-}
-
-void Execute::run(const std::string &execution_string, sql::ResultSet &result_set)
+void Execute::run(str_ref execution_string, sql::ResultSet &result_set)
 {
   if (not _session.isConcurrentExecuteAllowed())
   {
@@ -84,7 +79,8 @@
     {
       boost::this_thread::restore_interruption dl(_session.getThreadInterupt());
       
-      try {
+      try 
+      {
         thread->join();
       }
       catch(boost::thread_interrupted const&)
@@ -101,7 +97,7 @@
   }
 }
 
-void Execute::run(const std::string &execution_string)
+void Execute::run(str_ref execution_string)
 {
   if (not _session.isConcurrentExecuteAllowed())
   {
@@ -143,7 +139,8 @@
     {
       boost::this_thread::restore_interruption dl(_session.getThreadInterupt());
 
-      try {
+      try 
+      {
         thread->join();
       }
       catch(boost::thread_interrupted const&)

=== modified file 'drizzled/execute.h'
--- drizzled/execute.h	2011-04-13 12:46:37 +0000
+++ drizzled/execute.h	2011-08-10 17:58:23 +0000
@@ -32,9 +32,8 @@
 public:
   Execute(Session&, bool wait_arg);
 
-  void run(const std::string&);
-  void run(const char*, size_t);
-  void run(const std::string&, sql::ResultSet&);
+  void run(str_ref);
+  void run(str_ref, sql::ResultSet&);
 
   Session &session()
   {

=== modified file 'drizzled/field/blob.h'
--- drizzled/field/blob.h	2011-06-20 15:04:56 +0000
+++ drizzled/field/blob.h	2011-08-08 13:26:46 +0000
@@ -157,23 +157,18 @@
   void set_key_image(const unsigned char *buff,uint32_t length);
   inline void copy()
   {
-    unsigned char* tmp= get_ptr();
-    value.copy((char*) tmp, get_length(), charset());
-    tmp=(unsigned char*) value.ptr();
-    memcpy(ptr+sizeof(uint32_t),&tmp,sizeof(char*));
+    value.copy((char*)get_ptr(), get_length(), charset());
+    char* tmp= value.ptr();
+    memcpy(ptr + sizeof(uint32_t), &tmp, sizeof(char*));
   }
-  virtual unsigned char *pack(unsigned char *to, const unsigned char *from,
-                      uint32_t max_length, bool low_byte_first);
-  unsigned char *pack_key(unsigned char *to, const unsigned char *from,
-                  uint32_t max_length, bool low_byte_first);
-  virtual const unsigned char *unpack(unsigned char *to, const unsigned char *from,
-                              uint32_t , bool low_byte_first);
+  virtual unsigned char *pack(unsigned char *to, const unsigned char *from, uint32_t max_length, bool low_byte_first);
+  unsigned char *pack_key(unsigned char *to, const unsigned char *from, uint32_t max_length, bool low_byte_first);
+  virtual const unsigned char *unpack(unsigned char *to, const unsigned char *from, uint32_t , bool low_byte_first);
   void free() { value.free(); }
-  inline void clear_temporary() { memset(&value, 0, sizeof(value)); }
   friend int field_conv(Field *to,Field *from);
   uint32_t size_of() const { return sizeof(*this); }
   bool has_charset(void) const
-  { return charset() == &my_charset_bin ? false : true; }
+  { return charset() != &my_charset_bin; }
   uint32_t max_display_length();
 };
 

=== modified file 'drizzled/field/num.cc'
--- drizzled/field/num.cc	2011-07-05 14:36:13 +0000
+++ drizzled/field/num.cc	2011-08-10 16:48:48 +0000
@@ -224,10 +224,8 @@
 uint32_t Field_num::is_equal(CreateField *new_field_ptr)
 {
   return ((new_field_ptr->sql_type == real_type()) &&
-          ((new_field_ptr->flags & UNSIGNED_FLAG) ==
-           (uint32_t) (flags & UNSIGNED_FLAG)) &&
-          ((new_field_ptr->flags & AUTO_INCREMENT_FLAG) ==
-           (uint32_t) (flags & AUTO_INCREMENT_FLAG)) &&
+          ((new_field_ptr->flags & UNSIGNED_FLAG) == (uint32_t) (flags & UNSIGNED_FLAG)) &&
+          ((new_field_ptr->flags & AUTO_INCREMENT_FLAG) == (uint32_t) (flags & AUTO_INCREMENT_FLAG)) &&
           (new_field_ptr->length <= max_display_length()));
 }
 

=== modified file 'drizzled/field_iterator.cc'
--- drizzled/field_iterator.cc	2011-04-13 15:51:59 +0000
+++ drizzled/field_iterator.cc	2011-08-08 09:51:16 +0000
@@ -26,7 +26,7 @@
 
 namespace drizzled {
 
-const char *Field_iterator_table::name()
+const char *Field_iterator_table::name() const
 {
   return (*ptr)->field_name;
 }
@@ -264,18 +264,14 @@
 Natural_join_column *
 Field_iterator_table_ref::get_natural_column_ref()
 {
-  Natural_join_column *nj_col;
-
   assert(field_it == &natural_join_it);
   /*
     The field belongs to a NATURAL join, therefore the column reference was
     already created via one of the two constructor calls above. In this case
     we just return the already created column reference.
   */
-  nj_col= natural_join_it.column_ref();
-  assert(nj_col &&
-              (!nj_col->table_field ||
-               nj_col->table_ref->table == nj_col->table_field->getTable()));
+  Natural_join_column* nj_col= natural_join_it.column_ref();
+  assert(nj_col && (!nj_col->table_field || nj_col->table_ref->table == nj_col->table_field->getTable()));
   return nj_col;
 }
 

=== modified file 'drizzled/field_iterator.h'
--- drizzled/field_iterator.h	2011-04-13 15:51:59 +0000
+++ drizzled/field_iterator.h	2011-08-08 09:51:16 +0000
@@ -31,14 +31,14 @@
   Iterator over the fields of a generic table reference.
 */
 
-class Field_iterator: public memory::SqlAlloc
+class Field_iterator : public memory::SqlAlloc
 {
 public:
   virtual ~Field_iterator() {}
   virtual void set(TableList *)= 0;
   virtual void next()= 0;
-  virtual bool end_of_fields()= 0;              /* Return 1 at end of list */
-  virtual const char *name()= 0;
+  virtual bool end_of_fields() const= 0;              /* Return true at end of list */
+  virtual const char *name() const= 0;
   virtual Item *create_item(Session *)= 0;
   virtual Field *field()= 0;
 };
@@ -49,7 +49,7 @@
   table, or subquery.
 */
 
-class Field_iterator_table: public Field_iterator
+class Field_iterator_table : public Field_iterator
 {
   Field **ptr;
 public:
@@ -57,8 +57,8 @@
   void set(TableList *table);
   void set_table(Table *table);
   void next() { ptr++; }
-  bool end_of_fields() { return *ptr == 0; }
-  const char *name();
+  bool end_of_fields() const { return *ptr == 0; }
+  const char *name() const;
   Item *create_item(Session *session);
   Field *field() { return *ptr; }
 };
@@ -76,12 +76,11 @@
   List<Natural_join_column>::iterator column_ref_it;
   Natural_join_column *cur_column_ref;
 public:
-  Field_iterator_natural_join() :cur_column_ref(NULL) {}
-  ~Field_iterator_natural_join() {}
+  Field_iterator_natural_join() : cur_column_ref(NULL) {}
   void set(TableList *table);
   void next();
-  bool end_of_fields() { return !cur_column_ref; }
-  const char *name() { return cur_column_ref->name(); }
+  bool end_of_fields() const { return not cur_column_ref; }
+  const char *name() const { return cur_column_ref->name(); }
   Item *create_item(Session *session) { return cur_column_ref->create_item(session); }
   Field *field() { return cur_column_ref->field(); }
   Natural_join_column *column_ref() { return cur_column_ref; }
@@ -115,9 +114,9 @@
   Field_iterator_table_ref() :field_it(NULL) {}
   void set(TableList *table);
   void next();
-  bool end_of_fields()
+  bool end_of_fields() const
   { return (table_ref == last_leaf && field_it->end_of_fields()); }
-  const char *name() { return field_it->name(); }
+  const char *name() const { return field_it->name(); }
   const char *table_name();
   const char *db_name();
   Item *create_item(Session *session) { return field_it->create_item(session); }

=== modified file 'drizzled/function/find_in_set.cc'
--- drizzled/function/find_in_set.cc	2011-04-20 22:18:30 +0000
+++ drizzled/function/find_in_set.cc	2011-08-08 12:51:19 +0000
@@ -61,8 +61,7 @@
   }
   null_value=0;
 
-  int diff;
-  if ((diff=buffer->length() - find->length()) >= 0)
+  if (buffer->length() >= find->length())  
   {
     my_wc_t wc;
     const charset_info_st * const cs= cmp_collation.collation;
@@ -75,8 +74,7 @@
     while (1)
     {
       int symbol_len;
-      if ((symbol_len= cs->cset->mb_wc(cs, &wc, (unsigned char*) str_end,
-                                       (unsigned char*) real_end)) > 0)
+      if ((symbol_len= cs->cset->mb_wc(cs, &wc, (unsigned char*) str_end, (unsigned char*) real_end)) > 0)
       {
         const char *substr_end= str_end + symbol_len;
         bool is_last_item= (substr_end == real_end);
@@ -100,7 +98,7 @@
                wc == (my_wc_t) separator)
         return (int64_t) ++position;
       else
-        return 0L;
+        return 0;
     }
   }
   return 0;

=== modified file 'drizzled/generator/all_foreign_keys.h'
--- drizzled/generator/all_foreign_keys.h	2011-03-14 05:40:28 +0000
+++ drizzled/generator/all_foreign_keys.h	2011-08-08 12:51:19 +0000
@@ -49,8 +49,7 @@
       do {
         if (foreign_keys_iterator != table_message.fk_constraint_size())
         {
-          const message::Table::ForeignKeyConstraint &fk_constraint(table_message.fk_constraint(foreign_keys_iterator++));
-          return &fk_constraint;
+          return &table_message.fk_constraint(foreign_keys_iterator++);
         }
 
       } while ((table_ptr= all_tables_generator) && table_setup());
@@ -71,8 +70,7 @@
       } while ((table_ptr= all_tables_generator) && table_setup());
     }
 
-    ForeignKeyConstraintPair null_pair;
-    return null_pair;
+    return ForeignKeyConstraintPair();
   }
 };
 

=== modified file 'drizzled/internal/my_symlink2.cc'
--- drizzled/internal/my_symlink2.cc	2011-06-24 15:25:06 +0000
+++ drizzled/internal/my_symlink2.cc	2011-08-08 12:51:19 +0000
@@ -26,38 +26,30 @@
 #include <drizzled/error.h>
 #include <drizzled/internal/m_string.h>
 
-namespace drizzled
-{
-namespace internal
-{
+namespace drizzled {
+namespace internal {
 
 int my_create_with_symlink(const char *linkname, const char *filename,
                            int createflags, int access_flags, myf MyFlags)
 {
-  int file;
-  int tmp_errno;
   /* Test if we should create a link */
-  int create_link;
-  char abs_linkname[FN_REFLEN];
+  bool create_link= false;
   char rp_buff[PATH_MAX];
 
   if (my_disable_symlinks)
   {
     /* Create only the file, not the link and file */
-    create_link= 0;
     if (linkname)
       filename= linkname;
   }
-  else
+  else if (linkname)
   {
-    if (linkname)
-    {
-      if (!realpath(linkname,rp_buff))
-        my_load_path(rp_buff, linkname, NULL);
-      rp_buff[FN_REFLEN-1]= '\0';
-      strcpy(abs_linkname,rp_buff);
-    }
-    create_link= (linkname && strcmp(abs_linkname,filename));
+    if (!realpath(linkname,rp_buff))
+      my_load_path(rp_buff, linkname, NULL);
+    rp_buff[FN_REFLEN-1]= '\0';
+    char abs_linkname[FN_REFLEN];
+    strcpy(abs_linkname, rp_buff);
+    create_link= strcmp(abs_linkname, filename);
   }
 
   if (!(MyFlags & MY_DELETE_OLD))
@@ -76,28 +68,26 @@
     }
   }
 
-  if ((file=my_create(filename, createflags, access_flags, MyFlags)) >= 0)
+  int file= my_create(filename, createflags, access_flags, MyFlags);
+  if (file >= 0 && create_link)
   {
-    if (create_link)
+    /* Delete old link/file */
+    if (MyFlags & MY_DELETE_OLD)
+      my_delete(linkname, MYF(0));
+    /* Create link */
+    if (symlink(filename,linkname))
     {
-      /* Delete old link/file */
-      if (MyFlags & MY_DELETE_OLD)
-	my_delete(linkname, MYF(0));
-      /* Create link */
-      if (symlink(filename,linkname))
-      {
-	/* Fail, remove everything we have done */
-	tmp_errno=errno;
-	my_close(file,MYF(0));
-	my_delete(filename, MYF(0));
-	file= -1;
-	errno=tmp_errno;
-      }
-      else if (MyFlags & MY_SYNC_DIR)
-        my_sync_dir_by_file(linkname, MyFlags);
+      /* Fail, remove everything we have done */
+      int tmp_errno= errno;
+      my_close(file, MYF(0));
+      my_delete(filename, MYF(0));
+      file= -1;
+      errno= tmp_errno;
     }
+    else if (MyFlags & MY_SYNC_DIR)
+      my_sync_dir_by_file(linkname, MyFlags);
   }
-  return(file);
+  return file;
 }
 
 /*

=== modified file 'drizzled/item.cc'
--- drizzled/item.cc	2011-07-07 13:57:49 +0000
+++ drizzled/item.cc	2011-08-08 16:24:13 +0000
@@ -1003,19 +1003,15 @@
   return (Item**) not_found_item;
 }
 
-void Item::init_make_field(SendField *tmp_field,
-                           enum enum_field_types field_type_arg)
+void Item::init_make_field(SendField *tmp_field, enum_field_types field_type_arg)
 {
-  char *empty_name= (char*) "";
-  tmp_field->db_name=	empty_name;
-  tmp_field->org_table_name= empty_name;
-  tmp_field->org_col_name= empty_name;
-  tmp_field->table_name= empty_name;
+  tmp_field->db_name=	"";
+  tmp_field->org_table_name= "";
+  tmp_field->org_col_name= "";
+  tmp_field->table_name= "";
   tmp_field->col_name= name;
   tmp_field->charsetnr= collation.collation->number;
-  tmp_field->flags= (maybe_null ? 0 : NOT_NULL_FLAG) |
-                    (my_binary_compare(collation.collation) ?
-                      BINARY_FLAG : 0);
+  tmp_field->flags= (maybe_null ? 0 : NOT_NULL_FLAG) | (my_binary_compare(collation.collation) ? BINARY_FLAG : 0);
   tmp_field->type= field_type_arg;
   tmp_field->length= max_length;
   tmp_field->decimals= decimals;

=== modified file 'drizzled/item/create.cc'
--- drizzled/item/create.cc	2011-07-25 14:24:19 +0000
+++ drizzled/item/create.cc	2011-08-08 17:05:09 +0000
@@ -1580,7 +1580,7 @@
 
 struct Native_func_registry
 {
-  lex_string_t name;
+  const char* name;
   Create_func *builder;
 };
 
@@ -1595,62 +1595,61 @@
 
 static Native_func_registry func_array[] =
 {
-  { { C_STRING_WITH_LEN("BIN") }, BUILDER(Create_func_bin)},
-  { { C_STRING_WITH_LEN("CONCAT") }, BUILDER(Create_func_concat)},
-  { { C_STRING_WITH_LEN("CONCAT_WS") }, BUILDER(Create_func_concat_ws)},
-  { { C_STRING_WITH_LEN("CONV") }, BUILDER(Create_func_conv)},
-  { { C_STRING_WITH_LEN("COT") }, BUILDER(Create_func_cot)},
-  { { C_STRING_WITH_LEN("DATEDIFF") }, BUILDER(Create_func_datediff)},
-  { { C_STRING_WITH_LEN("DATE_FORMAT") }, BUILDER(Create_func_date_format)},
-  { { C_STRING_WITH_LEN("DAYNAME") }, BUILDER(Create_func_dayname)},
-  { { C_STRING_WITH_LEN("DAYOFMONTH") }, BUILDER(Create_func_dayofmonth)},
-  { { C_STRING_WITH_LEN("DAYOFWEEK") }, BUILDER(Create_func_dayofweek)},
-  { { C_STRING_WITH_LEN("DAYOFYEAR") }, BUILDER(Create_func_dayofyear)},
-  { { C_STRING_WITH_LEN("DEGREES") }, BUILDER(Create_func_degrees)},
-  { { C_STRING_WITH_LEN("EXPORT_SET") }, BUILDER(Create_func_export_set)},
-  { { C_STRING_WITH_LEN("FIELD") }, BUILDER(Create_func_field)},
-  { { C_STRING_WITH_LEN("FIND_IN_SET") }, BUILDER(Create_func_find_in_set)},
-  { { C_STRING_WITH_LEN("FOUND_ROWS") }, BUILDER(Create_func_found_rows)},
-  { { C_STRING_WITH_LEN("FROM_DAYS") }, BUILDER(Create_func_from_days)},
-  { { C_STRING_WITH_LEN("FROM_UNIXTIME") }, BUILDER(Create_func_from_unixtime)},
-  { { C_STRING_WITH_LEN("GREATEST") }, BUILDER(Create_func_greatest)},
-  { { C_STRING_WITH_LEN("IFNULL") }, BUILDER(Create_func_ifnull)},
-  { { C_STRING_WITH_LEN("INSTR") }, BUILDER(Create_func_instr)},
-  { { C_STRING_WITH_LEN("ISNULL") }, BUILDER(Create_func_isnull)},
-  { { C_STRING_WITH_LEN("LAST_DAY") }, BUILDER(Create_func_last_day)},
-  { { C_STRING_WITH_LEN("LAST_INSERT_ID") }, BUILDER(Create_func_last_insert_id)},
-  { { C_STRING_WITH_LEN("LCASE") }, BUILDER(Create_func_lcase)},
-  { { C_STRING_WITH_LEN("LEAST") }, BUILDER(Create_func_least)},
-  { { C_STRING_WITH_LEN("LOAD_FILE") }, BUILDER(Create_func_load_file)},
-  { { C_STRING_WITH_LEN("LOCATE") }, BUILDER(Create_func_locate)},
-  { { C_STRING_WITH_LEN("LOWER") }, BUILDER(Create_func_lcase)},
-  { { C_STRING_WITH_LEN("LPAD") }, BUILDER(Create_func_lpad)},
-  { { C_STRING_WITH_LEN("LTRIM") }, BUILDER(Create_func_ltrim)},
-  { { C_STRING_WITH_LEN("MAKEDATE") }, BUILDER(Create_func_makedate)},
-  { { C_STRING_WITH_LEN("MAKE_SET") }, BUILDER(Create_func_make_set)},
-  { { C_STRING_WITH_LEN("MONTHNAME") }, BUILDER(Create_func_monthname)},
-  { { C_STRING_WITH_LEN("NULLIF") }, BUILDER(Create_func_nullif)},
-  { { C_STRING_WITH_LEN("OCT") }, BUILDER(Create_func_oct)},
-  { { C_STRING_WITH_LEN("PERIOD_ADD") }, BUILDER(Create_func_period_add)},
-  { { C_STRING_WITH_LEN("PERIOD_DIFF") }, BUILDER(Create_func_period_diff)},
-  { { C_STRING_WITH_LEN("PI") }, BUILDER(Create_func_pi)},
-  { { C_STRING_WITH_LEN("RADIANS") }, BUILDER(Create_func_radians)},
-  { { C_STRING_WITH_LEN("ROUND") }, BUILDER(Create_func_round)},
-  { { C_STRING_WITH_LEN("ROW_COUNT") }, BUILDER(Create_func_row_count)},
-  { { C_STRING_WITH_LEN("RPAD") }, BUILDER(Create_func_rpad)},
-  { { C_STRING_WITH_LEN("RTRIM") }, BUILDER(Create_func_rtrim)},
-  { { C_STRING_WITH_LEN("SIGN") }, BUILDER(Create_func_sign)},
-  { { C_STRING_WITH_LEN("SPACE") }, BUILDER(Create_func_space)},
-  { { C_STRING_WITH_LEN("STRCMP") }, BUILDER(Create_func_strcmp)},
-  { { C_STRING_WITH_LEN("TAN") }, BUILDER(Create_func_tan)},
-  { { C_STRING_WITH_LEN("TIME_FORMAT") }, BUILDER(Create_func_time_format)},
-  { { C_STRING_WITH_LEN("TO_DAYS") }, BUILDER(Create_func_to_days)},
-  { { C_STRING_WITH_LEN("UCASE") }, BUILDER(Create_func_ucase)},
-  { { C_STRING_WITH_LEN("UNIX_TIMESTAMP") }, BUILDER(Create_func_unix_timestamp)},
-  { { C_STRING_WITH_LEN("UPPER") }, BUILDER(Create_func_ucase)},
-  { { C_STRING_WITH_LEN("WEEKDAY") }, BUILDER(Create_func_weekday)},
-
-  { {0, 0}, NULL}
+  { "BIN", BUILDER(Create_func_bin)},
+  { "CONCAT", BUILDER(Create_func_concat)},
+  { "CONCAT_WS", BUILDER(Create_func_concat_ws)},
+  { "CONV", BUILDER(Create_func_conv)},
+  { "COT", BUILDER(Create_func_cot)},
+  { "DATEDIFF", BUILDER(Create_func_datediff)},
+  { "DATE_FORMAT", BUILDER(Create_func_date_format)},
+  { "DAYNAME", BUILDER(Create_func_dayname)},
+  { "DAYOFMONTH", BUILDER(Create_func_dayofmonth)},
+  { "DAYOFWEEK", BUILDER(Create_func_dayofweek)},
+  { "DAYOFYEAR", BUILDER(Create_func_dayofyear)},
+  { "DEGREES", BUILDER(Create_func_degrees)},
+  { "EXPORT_SET", BUILDER(Create_func_export_set)},
+  { "FIELD", BUILDER(Create_func_field)},
+  { "FIND_IN_SET", BUILDER(Create_func_find_in_set)},
+  { "FOUND_ROWS", BUILDER(Create_func_found_rows)},
+  { "FROM_DAYS", BUILDER(Create_func_from_days)},
+  { "FROM_UNIXTIME", BUILDER(Create_func_from_unixtime)},
+  { "GREATEST", BUILDER(Create_func_greatest)},
+  { "IFNULL", BUILDER(Create_func_ifnull)},
+  { "INSTR", BUILDER(Create_func_instr)},
+  { "ISNULL", BUILDER(Create_func_isnull)},
+  { "LAST_DAY", BUILDER(Create_func_last_day)},
+  { "LAST_INSERT_ID", BUILDER(Create_func_last_insert_id)},
+  { "LCASE", BUILDER(Create_func_lcase)},
+  { "LEAST", BUILDER(Create_func_least)},
+  { "LOAD_FILE", BUILDER(Create_func_load_file)},
+  { "LOCATE", BUILDER(Create_func_locate)},
+  { "LOWER", BUILDER(Create_func_lcase)},
+  { "LPAD", BUILDER(Create_func_lpad)},
+  { "LTRIM", BUILDER(Create_func_ltrim)},
+  { "MAKEDATE", BUILDER(Create_func_makedate)},
+  { "MAKE_SET", BUILDER(Create_func_make_set)},
+  { "MONTHNAME", BUILDER(Create_func_monthname)},
+  { "NULLIF", BUILDER(Create_func_nullif)},
+  { "OCT", BUILDER(Create_func_oct)},
+  { "PERIOD_ADD", BUILDER(Create_func_period_add)},
+  { "PERIOD_DIFF", BUILDER(Create_func_period_diff)},
+  { "PI", BUILDER(Create_func_pi)},
+  { "RADIANS", BUILDER(Create_func_radians)},
+  { "ROUND", BUILDER(Create_func_round)},
+  { "ROW_COUNT", BUILDER(Create_func_row_count)},
+  { "RPAD", BUILDER(Create_func_rpad)},
+  { "RTRIM", BUILDER(Create_func_rtrim)},
+  { "SIGN", BUILDER(Create_func_sign)},
+  { "SPACE", BUILDER(Create_func_space)},
+  { "STRCMP", BUILDER(Create_func_strcmp)},
+  { "TAN", BUILDER(Create_func_tan)},
+  { "TIME_FORMAT", BUILDER(Create_func_time_format)},
+  { "TO_DAYS", BUILDER(Create_func_to_days)},
+  { "UCASE", BUILDER(Create_func_ucase)},
+  { "UNIX_TIMESTAMP", BUILDER(Create_func_unix_timestamp)},
+  { "UPPER", BUILDER(Create_func_ucase)},
+  { "WEEKDAY", BUILDER(Create_func_weekday)},
+  { NULL, NULL}
 };
 
 /*
@@ -1662,15 +1661,15 @@
 void item_create_init()
 {
   for (Native_func_registry* func= func_array; func->builder; func++)
-    FunctionContainer::getMutableMap()[string(func->name.str, func->name.length)]= func->builder;
+    FunctionContainer::getMutableMap()[func->name]= func->builder;
 }
 
 Create_func* find_native_function_builder(lex_string_t name)
 {
-  return find_ptr2(FunctionContainer::getMap(), string(name.str, name.length));
+  return find_ptr2(FunctionContainer::getMap(), name.str);
 }
 
-Item* create_func_char_cast(Session *session, Item *a, int len, const charset_info_st * const cs)
+Item* create_func_char_cast(Session *session, Item *a, int len, const charset_info_st* cs)
 {
   return new (session->mem) Item_char_typecast(a, len, cs ? cs : session->variables.getCollation());
 }

=== modified file 'drizzled/item/sum.cc'
--- drizzled/item/sum.cc	2011-07-05 14:36:13 +0000
+++ drizzled/item/sum.cc	2011-08-08 16:21:01 +0000
@@ -434,11 +434,10 @@
   {
     ((Item_field*) args[0])->field->make_field(tmp_field);
     /* For expressions only col_name should be non-empty string. */
-    char *empty_string= (char*)"";
-    tmp_field->db_name= empty_string;
-    tmp_field->org_table_name= empty_string;
-    tmp_field->table_name= empty_string;
-    tmp_field->org_col_name= empty_string;
+    tmp_field->db_name= "";
+    tmp_field->org_table_name= "";
+    tmp_field->table_name= "";
+    tmp_field->org_col_name= "";
     tmp_field->col_name= name;
     if (maybe_null)
       tmp_field->flags&= ~NOT_NULL_FLAG;
@@ -2587,7 +2586,7 @@
   tmp_table_param= new Tmp_Table_Param;
 
   /* Create a table with an unique key over all parameters */
-  for (uint32_t i=0; i < arg_count ; i++)
+  for (uint32_t i= 0; i < arg_count; i++)
   {
     Item *item=args[i];
     list.push_back(item);
@@ -2600,10 +2599,7 @@
   tmp_table_param->force_copy_fields= force_copy_fields;
   assert(table == 0);
 
-  if (!(table= create_tmp_table(session, tmp_table_param, list, (Order*) 0, 1,
-				0,
-				(select_lex->options | session->options),
-				HA_POS_ERROR, (char*)"")))
+  if (!(table= create_tmp_table(session, tmp_table_param, list, NULL, 1, 0, (select_lex->options | session->options), HA_POS_ERROR, "")))
   {
     return true;
   }

=== modified file 'drizzled/lex_input_stream.h'
--- drizzled/lex_input_stream.h	2011-08-03 10:04:55 +0000
+++ drizzled/lex_input_stream.h	2011-08-08 12:51:19 +0000
@@ -145,9 +145,9 @@
     End of file indicator for the query text to parse.
     @return true if there are no more characters to parse
   */
-  bool eof()
+  bool eof() const
   {
-    return (m_ptr >= m_end_of_query);
+    return m_ptr >= m_end_of_query;
   }
 
   /**
@@ -155,25 +155,25 @@
     @param n number of characters expected
     @return true if there are less than n characters to parse
   */
-  bool eof(int n)
+  bool eof(int n) const
   {
-    return ((m_ptr + n) >= m_end_of_query);
+    return m_ptr + n >= m_end_of_query;
   }
 
   /** Get the raw query buffer. */
-  const char *get_buf()
+  const char *get_buf() const
   {
     return m_buf;
   }
 
   /** Get the pre-processed query buffer. */
-  const char *get_cpp_buf()
+  const char *get_cpp_buf() const
   {
     return m_cpp_buf;
   }
 
   /** Get the end of the raw query buffer. */
-  const char *get_end_of_query()
+  const char *get_end_of_query() const
   {
     return m_end_of_query;
   }

=== modified file 'drizzled/memory/root.h'
--- drizzled/memory/root.h	2011-07-07 13:41:07 +0000
+++ drizzled/memory/root.h	2011-08-08 09:51:16 +0000
@@ -115,7 +115,7 @@
   char* strdup(str_ref);
   void init(size_t block_size= ROOT_MIN_BLOCK_SIZE);
 
-  inline bool alloc_root_inited()
+  bool alloc_root_inited() const
   {
     return min_malloc != 0;
   }

=== modified file 'drizzled/plugin/client.cc'
--- drizzled/plugin/client.cc	2011-05-28 14:26:21 +0000
+++ drizzled/plugin/client.cc	2011-08-08 17:15:11 +0000
@@ -77,10 +77,7 @@
 
 void plugin::Client::store(const char *from)
 {
-  if (from == NULL)
-    return store();
-
-  return store(from, strlen(from));
+  return from ? store(from, strlen(from)) : store();
 }
 
 

=== modified file 'drizzled/plugin/client.h'
--- drizzled/plugin/client.h	2011-06-16 19:51:35 +0000
+++ drizzled/plugin/client.h	2011-08-08 17:15:11 +0000
@@ -130,9 +130,9 @@
   virtual void store(const type::Time *from);
   virtual void store(const char *from);
   virtual void store(const char *from, size_t length)= 0;
-  virtual void store(const std::string &from)
+  virtual void store(str_ref from)
   {
-    store(from.c_str(), from.size());
+    store(from.data(), from.size());
   }
 
   /* Try to remove these. */

=== modified file 'drizzled/plugin/client/concurrent.h'
--- drizzled/plugin/client/concurrent.h	2011-06-28 06:01:55 +0000
+++ drizzled/plugin/client/concurrent.h	2011-08-10 17:58:23 +0000
@@ -101,11 +101,11 @@
   virtual void store(const type::Time*) {}
   virtual void store(const char*) {}
   virtual void store(const char*, size_t) {}
-  virtual void store(const std::string &) {}
+  virtual void store(str_ref) {}
   virtual bool haveError(void) { return false; }
   virtual bool wasAborted(void) { return false; }
 
-  void pushSQL(const std::string &arg)
+  void pushSQL(str_ref arg)
   {
     ::drizzled::error_t err_msg;
     ::drizzled::execute::Context context(arg.data(), arg.size(), err_msg);

=== modified file 'drizzled/plugin/null_client.h'
--- drizzled/plugin/null_client.h	2011-06-09 13:15:33 +0000
+++ drizzled/plugin/null_client.h	2011-08-10 17:58:23 +0000
@@ -34,7 +34,7 @@
 class NullClient: public Client
 {
   typedef std::vector<char> Bytes;
-  typedef std::queue <Bytes> Queue;
+  typedef std::queue<Bytes> Queue;
   Queue to_execute;
   bool is_dead;
   Bytes packet_buffer;
@@ -54,18 +54,13 @@
 
   virtual bool readCommand(char **packet, uint32_t& packet_length)
   {
-    while(not to_execute.empty())
+    while (not to_execute.empty())
     {
       Queue::value_type next= to_execute.front();
-      packet_buffer.resize(next.size());
-      memcpy(&packet_buffer[0], &next[0], next.size());
-
+      packet_buffer.assign(next.begin(), next.end());
       *packet= &packet_buffer[0];
-
       packet_length= next.size();
-
       to_execute.pop();
-
       return true;
     }
 
@@ -75,7 +70,6 @@
       packet_length= 1;
       *packet= &packet_buffer[0];
       is_dead= true;
-
       return true;
     }
 
@@ -83,8 +77,8 @@
     return false;
   }
 
-  virtual void sendOK(void) {}
-  virtual void sendEOF(void) {}
+  virtual void sendOK() {}
+  virtual void sendEOF() {}
   virtual void sendError(const drizzled::error_t, const char*) {}
   virtual void sendFields(List<Item>&) {}
   virtual void store(Field *) {}
@@ -97,11 +91,11 @@
   virtual void store(const type::Time*) {}
   virtual void store(const char*) {}
   virtual void store(const char*, size_t) {}
-  virtual void store(const std::string &) {}
-  virtual bool haveError(void) { return false; }
-  virtual bool wasAborted(void) { return false; }
+  virtual void store(str_ref) {}
+  virtual bool haveError() { return false; }
+  virtual bool wasAborted() { return false; }
 
-  void pushSQL(const std::string &arg)
+  void pushSQL(str_ref arg)
   {
     Bytes byte;
     typedef boost::tokenizer<boost::escaped_list_separator<char> > Tokenizer;
@@ -111,7 +105,7 @@
     {
       byte.resize(iter->size() +1); // +1 for the COM_QUERY
       byte[0]= COM_QUERY;
-      memcpy(&byte[1], iter->c_str(), iter->size());
+      memcpy(&byte[1], iter->data(), iter->size());
       to_execute.push(byte);
     }
   }

=== modified file 'drizzled/session.cc'
--- drizzled/session.cc	2011-08-05 12:55:59 +0000
+++ drizzled/session.cc	2011-08-08 16:24:13 +0000
@@ -861,21 +861,12 @@
                               instead of using lex_str value
   @return  NULL on failure, or pointer to the lex_string_t object
 */
-lex_string_t *Session::make_lex_string(lex_string_t *lex_str,
-                                     const std::string &str,
-                                     bool allocate_lex_string)
-{
-  return make_lex_string(lex_str, str.c_str(), str.length(), allocate_lex_string);
-}
-
-lex_string_t *Session::make_lex_string(lex_string_t *lex_str,
-                                     const char* str, uint32_t length,
-                                     bool allocate_lex_string)
-{
-  if (allocate_lex_string)
+lex_string_t* Session::make_lex_string(lex_string_t* lex_str, str_ref str)
+{
+  if (not lex_str)
     lex_str= new (mem) lex_string_t;
-  lex_str->str= mem_root->strdup(str, length);
-  lex_str->length= length;
+  lex_str->str= mem_root->strdup(str);
+  lex_str->length= str.size();
   return lex_str;
 }
 
@@ -894,18 +885,11 @@
   item->maybe_null=1;
   field_list.push_back(item= new Item_empty_string("key", NAME_CHAR_LEN, cs));
   item->maybe_null=1;
-  field_list.push_back(item=
-    new Item_empty_string("key_len",
-                          MAX_KEY *
-                          (MAX_KEY_LENGTH_DECIMAL_WIDTH + 1 /* for comma */),
-                          cs));
-  item->maybe_null=1;
-  field_list.push_back(item=new Item_empty_string("ref",
-                                                  NAME_CHAR_LEN*MAX_REF_PARTS,
-                                                  cs));
-  item->maybe_null=1;
-  field_list.push_back(item= new Item_return_int("rows", 10,
-                                                 DRIZZLE_TYPE_LONGLONG));
+  field_list.push_back(item= new Item_empty_string("key_len", MAX_KEY * (MAX_KEY_LENGTH_DECIMAL_WIDTH + 1 /* for comma */), cs));
+  item->maybe_null=1;
+  field_list.push_back(item= new Item_empty_string("ref", NAME_CHAR_LEN*MAX_REF_PARTS, cs));
+  item->maybe_null=1;
+  field_list.push_back(item= new Item_return_int("rows", 10, DRIZZLE_TYPE_LONGLONG));
   if (lex().describe & DESCRIBE_EXTENDED)
   {
     field_list.push_back(item= new Item_float("filtered", 0.1234, 2, 4));
@@ -1332,7 +1316,6 @@
   char buff[MAX_FIELD_WIDTH];
   String tmp(buff,sizeof(buff),&my_charset_bin),*res;
   tmp.length(0);
-  Item *item;
 
   if (unit->offset_limit_cnt)
   {						// using limit offset,count
@@ -1344,7 +1327,7 @@
     my_message(ER_TOO_MANY_ROWS, ER(ER_TOO_MANY_ROWS), MYF(0));
     return 1;
   }
-  while ((item=li++))
+  while (Item* item=li++)
   {
     res=item->str_result(&tmp);
     if (!res)					// If NULL

=== modified file 'drizzled/session.h'
--- drizzled/session.h	2011-08-05 12:55:59 +0000
+++ drizzled/session.h	2011-08-08 15:51:23 +0000
@@ -117,7 +117,7 @@
   memory::Root& mem;
   memory::Root* mem_root; /**< Pointer to current memroot */
 
-  uint64_t getXaId()
+  uint64_t getXaId() const
   {
     return xa_id;
   }
@@ -232,7 +232,7 @@
     scoreboard_index= in_scoreboard_index;
   }
 
-  bool isOriginatingServerUUIDSet()
+  bool isOriginatingServerUUIDSet() const
   {
     return originating_server_uuid_set;
   }
@@ -243,7 +243,7 @@
     originating_server_uuid_set= true;
   }
 
-  std::string &getOriginatingServerUUID()
+  const std::string &getOriginatingServerUUID() const
   {
     return originating_server_uuid;
   }
@@ -253,7 +253,7 @@
     originating_commit_id= in_originating_commit_id;
   }
 
-  uint64_t getOriginatingCommitID()
+  uint64_t getOriginatingCommitID() const
   {
     return originating_commit_id;
   }
@@ -272,7 +272,7 @@
   const char *_where;
 
 public:
-  const char *where()
+  const char *where() const
   {
     return _where;
   }
@@ -535,7 +535,7 @@
     _killed= arg;
   }
 
-  killed_state_t getKilled()
+  killed_state_t getKilled() const
   {
     return _killed;
   }
@@ -583,7 +583,7 @@
   /** set during loop of derived table processing */
   bool derived_tables_processing;
 
-  bool doing_tablespace_operation()
+  bool doing_tablespace_operation() const
   {
     return tablespace_op;
   }
@@ -716,7 +716,7 @@
     if (first_successful_insert_id_in_cur_stmt == 0)
       first_successful_insert_id_in_cur_stmt= id_arg;
   }
-  inline uint64_t read_first_successful_insert_id_in_prev_stmt()
+  inline uint64_t read_first_successful_insert_id_in_prev_stmt() const
   {
     return first_successful_insert_id_in_prev_stmt;
   }
@@ -826,13 +826,7 @@
     return server_status & SERVER_STATUS_IN_TRANS;
   }
 
-  lex_string_t *make_lex_string(lex_string_t *lex_str,
-                              const char* str, uint32_t length,
-                              bool allocate_lex_string);
-
-  lex_string_t *make_lex_string(lex_string_t *lex_str,
-                              const std::string &str,
-                              bool allocate_lex_string);
+  lex_string_t* make_lex_string(lex_string_t*, str_ref);
 
   void send_explain_fields(select_result*);
 

=== modified file 'drizzled/sql_base.cc'
--- drizzled/sql_base.cc	2011-08-05 13:53:37 +0000
+++ drizzled/sql_base.cc	2011-08-08 09:51:16 +0000
@@ -3268,23 +3268,19 @@
                   List<TableList> *from_clause, TableList *tables,
                   TableList **leaves, bool select_insert)
 {
-  uint32_t tablenr= 0;
-
-  assert ((select_insert && !tables->next_name_resolution_table) || !tables ||
+  assert((select_insert && !tables->next_name_resolution_table) || !tables ||
           (context->table_list && context->first_name_resolution_table));
   /*
     this is used for INSERT ... SELECT.
     For select we setup tables except first (and its underlying tables)
   */
-  TableList *first_select_table= (select_insert ?  tables->next_local: NULL);
+  TableList *first_select_table= select_insert ? tables->next_local : NULL;
 
-  if (!(*leaves))
+  if (not *leaves)
     make_leaves_list(leaves, tables);
 
-  TableList *table_list;
-  for (table_list= *leaves;
-       table_list;
-       table_list= table_list->next_leaf, tablenr++)
+  uint32_t tablenr= 0;
+  for (TableList* table_list= *leaves; table_list; table_list= table_list->next_leaf, tablenr++)
   {
     Table *table= table_list->table;
     table->pos_in_table_list= table_list;
@@ -3345,8 +3341,7 @@
 {
   TableList *leaves_tmp= NULL;
 
-  if (setup_tables(session, context, from_clause, tables,
-                   &leaves_tmp, select_insert))
+  if (setup_tables(session, context, from_clause, tables, &leaves_tmp, select_insert))
     return true;
 
   if (leaves)
@@ -3435,12 +3430,11 @@
 
     for (; !field_iterator.end_of_fields(); field_iterator.next())
     {
-      Item *item;
-
-      if (!(item= field_iterator.create_item(session)))
+      Item *item= field_iterator.create_item(session);
+      if (not item)
         return true;
 
-      if (!found)
+      if (not found)
       {
         found= true;
         it->replace(item); /* Replace '*' with the first found item. */

=== modified file 'drizzled/sql_error.cc'
--- drizzled/sql_error.cc	2011-07-25 14:24:19 +0000
+++ drizzled/sql_error.cc	2011-08-08 17:15:11 +0000
@@ -203,8 +203,7 @@
   { C_STRING_WITH_LEN("?") }
 };
 
-bool show_warnings(Session *session,
-                   bitset<DRIZZLE_ERROR::NUM_ERRORS> &levels_to_show)
+bool show_warnings(Session *session, bitset<DRIZZLE_ERROR::NUM_ERRORS> &levels_to_show)
 {
   List<Item> field_list;
 
@@ -229,8 +228,7 @@
       continue;
     if (idx > unit->select_limit_cnt)
       break;
-    session->getClient()->store(warning_level_names[err->level].str,
-                                warning_level_names[err->level].length);
+    session->getClient()->store(warning_level_names[err->level]);
     session->getClient()->store((uint32_t) err->code);
     session->getClient()->store(err->msg, strlen(err->msg));
     if (session->getClient()->flush())

=== modified file 'drizzled/sql_insert.cc'
--- drizzled/sql_insert.cc	2011-08-03 10:04:55 +0000
+++ drizzled/sql_insert.cc	2011-08-08 09:51:16 +0000
@@ -550,14 +550,8 @@
      than INSERT.
   */
 
-  if (setup_tables_and_check_access(session, &session->lex().select_lex.context,
-                                    &session->lex().select_lex.top_join_list,
-                                    table_list,
-                                    &session->lex().select_lex.leaf_tables,
-                                    select_insert))
-    return true;
-
-  return false;
+  return setup_tables_and_check_access(session, &session->lex().select_lex.context,
+    &session->lex().select_lex.top_join_list, table_list, &session->lex().select_lex.leaf_tables, select_insert);
 }
 
 
@@ -633,8 +627,7 @@
   if (duplic == DUP_UPDATE)
   {
     /* it should be allocated before Item::fix_fields() */
-    if (table_list->set_insert_values(session->mem_root))
-      return true;
+    table_list->set_insert_values();
   }
 
   if (prepare_insert_check_table(session, table_list, fields, select_insert))

=== modified file 'drizzled/sql_list.h'
--- drizzled/sql_list.h	2011-06-24 14:31:26 +0000
+++ drizzled/sql_list.h	2011-08-07 22:41:28 +0000
@@ -277,7 +277,7 @@
   base_list *list;
   list_node **el,**prev,*current;
 public:
-  void sublist(base_list &ls, uint32_t elm)
+  void sublist(base_list &ls, uint32_t elm) const
   {
     ls.first= *el;
     ls.last= list->last;

=== modified file 'drizzled/sql_parse.cc'
--- drizzled/sql_parse.cc	2011-08-05 13:28:48 +0000
+++ drizzled/sql_parse.cc	2011-08-08 15:51:23 +0000
@@ -409,8 +409,8 @@
      We have to make non const db_name & table_name
      because of lower_case_table_names
   */
-  session.make_lex_string(&db, "data_dictionary", sizeof("data_dictionary"), false);
-  session.make_lex_string(&table, schema_table_name, false);
+  session.make_lex_string(&db, str_ref("data_dictionary"));
+  session.make_lex_string(&table, schema_table_name);
   return not sel.add_table_to_list(&session, new Table_ident(db, table), NULL, table_options, TL_READ);
 }
 

=== modified file 'drizzled/sql_string.cc'
--- drizzled/sql_string.cc	2011-08-05 10:58:50 +0000
+++ drizzled/sql_string.cc	2011-08-08 13:26:46 +0000
@@ -184,16 +184,14 @@
   str_length=str.str_length;
   memmove(Ptr, str.Ptr, str_length);		// May be overlapping
   Ptr[str_length]=0;
-  str_charset=str.str_charset;
+  str_charset= str.str_charset;
 }
 
-void String::copy(const std::string& arg, const charset_info_st * const cs)	// Allocate new string
+void String::copy(const std::string& arg, const charset_info_st* cs) // Allocate new string
 {
   alloc(arg.size());
-
-  if ((str_length= arg.size()))
-    memcpy(Ptr, arg.c_str(), arg.size());
-
+  str_length= arg.size();
+  memcpy(Ptr, arg.c_str(), arg.size());
   Ptr[arg.size()]= 0;
   str_charset= cs;
 }
@@ -315,19 +313,17 @@
   append(s, arg_length);
 }
 
-size_t String::numchars()
+size_t String::numchars() const
 {
   return str_charset->cset->numchars(str_charset, Ptr, Ptr+str_length);
 }
 
-int String::charpos(int i,size_t offset)
+int String::charpos(int i,size_t offset) const
 {
-  if (i <= 0)
-    return i;
-  return str_charset->cset->charpos(str_charset,Ptr+offset,Ptr+str_length,i);
+  return i <= 0 ? i : str_charset->cset->charpos(str_charset, Ptr + offset, Ptr + str_length, i);
 }
 
-int String::strstr(const String &s,size_t offset)
+int String::strstr(const String &s, size_t offset)
 {
   if (s.length() + offset <= str_length)
   {

=== modified file 'drizzled/sql_string.h'
--- drizzled/sql_string.h	2011-08-05 10:58:50 +0000
+++ drizzled/sql_string.h	2011-08-08 13:26:46 +0000
@@ -275,8 +275,8 @@
   friend int sortcmp(const String *a,const String *b, const charset_info_st * const cs);
   friend int stringcmp(const String *a,const String *b);
   friend String *copy_if_not_alloced(String *a,String *b,size_t arg_length);
-  size_t numchars();
-  int charpos(int i,size_t offset=0);
+  size_t numchars() const;
+  int charpos(int i, size_t offset= 0) const;
 
   void reserve(size_t space_needed)
   {

=== modified file 'drizzled/sql_table.cc'
--- drizzled/sql_table.cc	2011-07-07 13:41:07 +0000
+++ drizzled/sql_table.cc	2011-08-08 12:51:19 +0000
@@ -2137,16 +2137,13 @@
 
 bool analyze_table(Session* session, TableList* tables)
 {
-  thr_lock_type lock_type = TL_READ_NO_INSERT;
-
-  return(admin_table(session, tables, "analyze", lock_type, true, &Cursor::ha_analyze));
+  return admin_table(session, tables, "analyze", TL_READ_NO_INSERT, true, &Cursor::ha_analyze);
 }
 
 
 bool check_table(Session* session, TableList* tables)
 {
-  thr_lock_type lock_type = TL_READ_NO_INSERT;
-  return admin_table(session, tables, "check", lock_type, false, &Cursor::ha_check);
+  return admin_table(session, tables, "check", TL_READ_NO_INSERT, false, &Cursor::ha_check);
 }
 
 } /* namespace drizzled */

=== modified file 'drizzled/sql_yacc.yy'
--- drizzled/sql_yacc.yy	2011-08-05 13:53:37 +0000
+++ drizzled/sql_yacc.yy	2011-08-08 17:05:09 +0000
@@ -3077,7 +3077,6 @@
           }
           opt_udf_expr_list ')'
           {
-            Create_func *builder;
             Item *item= NULL;
 
             /*
@@ -3089,25 +3088,21 @@
 
               This will be revised with WL#2128 (SQL PATH)
             */
-            builder= find_native_function_builder($1);
-            if (builder)
+            if (Create_func* builder= find_native_function_builder($1))
             {
               item= builder->create(YYSession, $1, $4);
             }
-            else
+            else if (const plugin::Function* udf= $<udf>3) /* Retrieving the result of service::Function::get */
             {
-              /* Retrieving the result of service::Function::get */
-              const plugin::Function *udf= $<udf>3;
-              if (udf)
-              {
-                item= Create_udf_func::s_singleton.create(YYSession, udf, $4);
-              } else {
-                /* fix for bug 250065, from Andrew Garner <muzazzi@gmail.com> */
-                my_error(ER_SP_DOES_NOT_EXIST, MYF(0), "FUNCTION", $1.str);
-              }
+	          item= Create_udf_func::s_singleton.create(YYSession, udf, $4);
+            } 
+			else 
+			{
+              /* fix for bug 250065, from Andrew Garner <muzazzi@gmail.com> */
+              my_error(ER_SP_DOES_NOT_EXIST, MYF(0), "FUNCTION", $1.str);
             }
 
-            if (! ($$= item))
+            if (not ($$= item))
             {
               DRIZZLE_YYABORT;
             }

=== modified file 'drizzled/statement/alter_schema.cc'
--- drizzled/statement/alter_schema.cc	2011-07-25 14:24:19 +0000
+++ drizzled/statement/alter_schema.cc	2011-08-08 12:51:19 +0000
@@ -84,9 +84,7 @@
   
   drizzled::message::update(schema_message);
 
-  bool res= schema::alter(session(), schema_message, *old_definition);
-
-  return not res;
+  return not schema::alter(session(), schema_message, *old_definition);
 }
 
 } /* namespace drizzled */

=== modified file 'drizzled/statement/check.cc'
--- drizzled/statement/check.cc	2011-06-23 10:02:30 +0000
+++ drizzled/statement/check.cc	2011-08-08 13:26:46 +0000
@@ -32,12 +32,10 @@
   TableList *first_table= (TableList *) lex().select_lex.table_list.first;
   TableList *all_tables= lex().query_tables;
   assert(first_table == all_tables && first_table != 0);
-  Select_Lex *select_lex= &lex().select_lex;
   bool res= check_table(&session(), first_table);
-  select_lex->table_list.first= (unsigned char*) first_table;
+  lex().select_lex.table_list.first= (unsigned char*) first_table;
   lex().query_tables=all_tables;
   return res;
 }
 
 } /* namespace drizzled */
-

=== modified file 'drizzled/statement/execute.cc'
--- drizzled/statement/execute.cc	2011-07-25 14:24:19 +0000
+++ drizzled/statement/execute.cc	2011-08-10 17:58:23 +0000
@@ -37,7 +37,7 @@
 namespace statement {
 
 Execute::Execute(Session *in_session,
-                 drizzled::execute_string_t to_execute_arg,
+                 execute_string_t to_execute_arg,
                  bool is_quiet_arg,
                  bool is_concurrent_arg,
                  bool should_wait_arg) :
@@ -121,7 +121,7 @@
     }
 
     drizzled::Execute executer(session(), should_wait);
-    executer.run(to_execute.str, to_execute.length);
+    executer.run(to_execute);
   }
   else // Non-concurrent run.
   {

=== modified file 'drizzled/system_variables.h'
--- drizzled/system_variables.h	2011-04-19 13:18:03 +0000
+++ drizzled/system_variables.h	2011-08-08 09:51:16 +0000
@@ -82,7 +82,7 @@
   /* Both charset and collation parts of these variables are important */
   const charset_info_st	*collation_server;
 
-  inline const charset_info_st  *getCollation(void) 
+  const charset_info_st* getCollation() const
   {
     return collation_server;
   }

=== modified file 'drizzled/table/instance/base.cc'
--- drizzled/table/instance/base.cc	2011-08-05 09:22:50 +0000
+++ drizzled/table/instance/base.cc	2011-08-08 16:21:01 +0000
@@ -762,10 +762,10 @@
     {
       keyinfo->flags|= HA_USES_COMMENT;
       keyinfo->comment.length= indx.comment().length();
-      keyinfo->comment.str= strdup(indx.comment().c_str(), keyinfo->comment.length);
+      keyinfo->comment.str= mem().strdup(indx.comment());
     }
 
-    keyinfo->name= strdup(indx.name().c_str(), indx.name().length());
+    keyinfo->name= mem().strdup(indx.name());
 
     addKeyName(string(keyinfo->name, indx.name().length()));
   }
@@ -931,17 +931,13 @@
 
     for (int n= 0; n < field_options.field_value_size(); n++)
     {
-      t->type_names[n]= strdup(field_options.field_value(n).c_str(), field_options.field_value(n).length());
+      t->type_names[n]= mem().strdup(field_options.field_value(n));
 
       /* 
        * Go ask the charset what the length is as for "" length=1
        * and there's stripping spaces or some other crack going on.
      */
-      uint32_t lengthsp;
-      lengthsp= charset->cset->lengthsp(charset,
-                                        t->type_names[n],
-                                        field_options.field_value(n).length());
-      t->type_lengths[n]= lengthsp;
+      t->type_lengths[n]= charset->cset->lengthsp(charset, t->type_names[n], field_options.field_value(n).length());
     }
     interval_nr++;
   }
@@ -1001,11 +997,8 @@
     }
     else
     {
-      size_t len= pfield.comment().length();
-      const char* str= pfield.comment().c_str();
-
-      comment.str= strdup(str, len);
-      comment.length= len;
+      comment.str= mem().strdup(pfield.comment());
+      comment.length= pfield.comment().size();
     }
 
     enum_field_types field_type;
@@ -1608,17 +1601,9 @@
   return ret;
 }
 
-int TableShare::open_table_from_share_inner(Session *session,
-                                            const char *alias,
-                                            uint32_t db_stat,
-                                            Table &outparam)
+int TableShare::open_table_from_share_inner(Session *session, const char *alias, uint32_t db_stat, Table &outparam)
 {
-  int local_error;
-  uint32_t records;
-  unsigned char *record= NULL;
-  Field **field_ptr;
-
-  local_error= 1;
+  int local_error= 1;
   outparam.resetTable(session, this, db_stat);
 
   outparam.setAlias(alias);
@@ -1628,13 +1613,13 @@
     return local_error;
 
   local_error= 4;
-  records= 0;
-  if ((db_stat & HA_OPEN_KEYFILE))
+  uint32_t records= 0;
+  if (db_stat & HA_OPEN_KEYFILE)
     records=1;
 
   records++;
 
-  record= outparam.alloc(rec_buff_length * records);
+  unsigned char* record= outparam.alloc(rec_buff_length * records);
 
   if (records == 0)
   {
@@ -1668,7 +1653,7 @@
     memcpy(outparam.getUpdateRecord(), getDefaultValues(), null_bytes);
   }
 
-  field_ptr = new (outparam.mem()) Field*[_field_size + 1];
+  Field** field_ptr = new (outparam.mem()) Field*[_field_size + 1];
 
   outparam.setFields(field_ptr);
 
@@ -1693,35 +1678,24 @@
   /* Fix key->name and key_part->field */
   if (key_parts)
   {
-    KeyInfo	*local_key_info, *key_info_end;
-    KeyPartInfo *key_part;
-    uint32_t n_length;
-    n_length= keys*sizeof(KeyInfo) + key_parts*sizeof(KeyPartInfo);
-    local_key_info= (KeyInfo*) outparam.alloc(n_length);
+    uint32_t n_length= keys * sizeof(KeyInfo) + key_parts * sizeof(KeyPartInfo);
+    KeyInfo* local_key_info= (KeyInfo*) outparam.alloc(n_length);
     outparam.key_info= local_key_info;
-    key_part= (reinterpret_cast<KeyPartInfo*> (local_key_info+keys));
+    KeyPartInfo* key_part= reinterpret_cast<KeyPartInfo*>(local_key_info+keys);
 
     memcpy(local_key_info, key_info, sizeof(*local_key_info)*keys);
-    memcpy(key_part, key_info[0].key_part, (sizeof(*key_part) *
-                                            key_parts));
+    memcpy(key_part, key_info[0].key_part, sizeof(*key_part) * key_parts);
 
-    for (key_info_end= local_key_info + keys ;
-         local_key_info < key_info_end ;
-         local_key_info++)
+    for (KeyInfo* key_info_end= local_key_info + keys; local_key_info < key_info_end; local_key_info++)
     {
-      KeyPartInfo *key_part_end;
-
       local_key_info->table= &outparam;
       local_key_info->key_part= key_part;
 
-      for (key_part_end= key_part+ local_key_info->key_parts ;
-           key_part < key_part_end ;
-           key_part++)
+      for (KeyPartInfo* key_part_end= key_part+ local_key_info->key_parts; key_part < key_part_end; key_part++)
       {
         Field *local_field= key_part->field= outparam.getField(key_part->fieldnr-1);
 
-        if (local_field->key_length() != key_part->length &&
-            !(local_field->flags & BLOB_FLAG))
+        if (local_field->key_length() != key_part->length && not (local_field->flags & BLOB_FLAG))
         {
           /*
             We are using only a prefix of the column as a key:
@@ -2003,27 +1977,15 @@
                                         field_name,
                                         this);
   case DRIZZLE_TYPE_TIME:
-    return new (&mem_root) field::Time(ptr,
-                                       field_length,
-                                       null_pos,
-                                       null_bit,
-                                       field_name);
+    return new (&mem_root) field::Time(ptr, field_length, null_pos, null_bit, field_name);
   case DRIZZLE_TYPE_DATE:
-    return new (&mem_root) Field_date(ptr,
-                                 null_pos,
-                                 null_bit,
-                                 field_name);
+    return new (&mem_root) Field_date(ptr, null_pos, null_bit, field_name);
   case DRIZZLE_TYPE_DATETIME:
-    return new (&mem_root) Field_datetime(ptr,
-                                     null_pos,
-                                     null_bit,
-                                     field_name);
+    return new (&mem_root) Field_datetime(ptr, null_pos, null_bit, field_name);
   case DRIZZLE_TYPE_NULL:
-    return new (&mem_root) Field_null(ptr,
-                                      field_length,
-                                      field_name);
+    return new (&mem_root) Field_null(ptr, field_length, field_name);
   }
-  assert(0);
+  assert(false);
   abort();
 }
 

=== modified file 'drizzled/table/instance/base.h'
--- drizzled/table/instance/base.h	2011-08-05 12:29:44 +0000
+++ drizzled/table/instance/base.h	2011-08-08 16:21:01 +0000
@@ -175,11 +175,6 @@
     return mem_root.alloc(arg);
   }
 
-  char *strdup(const char *str_arg, size_t len_arg)
-  {
-    return mem_root.strdup(str_arg, len_arg);
-  }
-
   memory::Root& mem()
   {
     return mem_root;

=== modified file 'drizzled/table/singular.cc'
--- drizzled/table/singular.cc	2011-07-05 14:36:13 +0000
+++ drizzled/table/singular.cc	2011-08-08 12:51:19 +0000
@@ -126,12 +126,8 @@
 
 bool Singular::open_tmp_table()
 {
-  int error;
-  
   identifier::Table identifier(getShare()->getSchemaName(), getShare()->getTableName(), getShare()->getPath());
-  if ((error=cursor->ha_open(identifier,
-                             O_RDWR,
-                             HA_OPEN_TMP_TABLE | HA_OPEN_INTERNAL_TABLE)))
+  if (int error= cursor->ha_open(identifier, O_RDWR, HA_OPEN_TMP_TABLE | HA_OPEN_INTERNAL_TABLE))
   {
     print_error(error, MYF(0));
     db_stat= 0;
@@ -303,17 +299,11 @@
   if (cursor)
   {
     if (db_stat)
-    {
-      cursor->closeMarkForDelete(getShare()->getTableName());
-    }
+      cursor->closeMarkForDelete();
 
     identifier::Table identifier(getShare()->getSchemaName(), getShare()->getTableName(), getShare()->getTableName());
     drizzled::error_t ignored;
-    plugin::StorageEngine::dropTable(*in_use,
-                                     *getShare()->getEngine(),
-                                     identifier,
-                                     ignored);
-
+    plugin::StorageEngine::dropTable(*in_use, *getShare()->getEngine(), identifier, ignored);
     delete cursor;
   }
 
@@ -328,6 +318,5 @@
   in_use->set_proc_info(save_proc_info);
 }
 
-
 } /* namespace table */
 } /* namespace drizzled */

=== modified file 'drizzled/table_list.cc'
--- drizzled/table_list.cc	2011-08-05 13:12:04 +0000
+++ drizzled/table_list.cc	2011-08-08 09:51:16 +0000
@@ -29,19 +29,17 @@
 
 namespace drizzled {
 
-bool TableList::set_insert_values(memory::Root *)
+void TableList::set_insert_values()
 {
   if (table)
   {
     table->insert_values.resize(table->getShare()->rec_buff_length);
   }
-
-  return false;
 }
 
-bool TableList::is_leaf_for_name_resolution()
+bool TableList::is_leaf_for_name_resolution() const
 {
-  return (is_natural_join || is_join_columns_complete || !nested_join);
+  return is_natural_join || is_join_columns_complete || not nested_join;
 }
 
 TableList *TableList::find_underlying_table(Table *table_to_find)

=== modified file 'drizzled/table_list.h'
--- drizzled/table_list.h	2011-08-05 13:28:48 +0000
+++ drizzled/table_list.h	2011-08-08 09:51:16 +0000
@@ -239,7 +239,7 @@
    * @retval
    *  true - out of memory
    */
-  bool set_insert_values(memory::Root *mem_root);
+  void set_insert_values();
   /**
    * Find underlying base tables (TableList) which represent given
    * table_to_find (Table)
@@ -298,7 +298,7 @@
    * @retval
    *  true if a leaf, false otherwise.
    */
-  bool is_leaf_for_name_resolution();
+  bool is_leaf_for_name_resolution() const;
   inline TableList *top_table()
   { return this; }
 

=== modified file 'drizzled/temporal_interval.h'
--- drizzled/temporal_interval.h	2011-03-28 02:46:21 +0000
+++ drizzled/temporal_interval.h	2011-08-08 09:51:16 +0000
@@ -27,8 +27,7 @@
 #include <drizzled/item.h>
 #include <drizzled/type/time.h>
 
-namespace drizzled 
-{
+namespace drizzled {
 
 /**
  * @brief
@@ -93,25 +92,25 @@
     return neg;
   }
 
-  inline uint32_t  get_year() { return year; }
+  inline uint32_t  get_year() const { return year; }
   inline void set_year(uint32_t new_year) { year = new_year; }
 
-  inline uint32_t  get_month(){ return month; }
+  inline uint32_t  get_month() const { return month; }
   inline void set_month(uint32_t new_month) { month = new_month; }
 
-  inline uint32_t  get_day(){ return day; }
+  inline uint32_t  get_day() const { return day; }
   inline void set_day(uint32_t new_day) { day = new_day; }
 
-  inline uint32_t  get_hour(){ return hour; }
+  inline uint32_t  get_hour() const { return hour; }
   inline void set_hour(uint32_t new_hour) { hour = new_hour; }
 
-  inline uint64_t  get_minute(){ return minute; }
+  inline uint64_t  get_minute() const { return minute; }
   inline void set_minute(uint32_t new_minute) { minute = new_minute; }
 
-  inline uint64_t  get_second(){ return second; }
+  inline uint64_t  get_second() const { return second; }
   inline void set_second(uint32_t new_second) { second = new_second; }
 
-  inline uint64_t  get_second_part(){ return second_part; }
+  inline uint64_t  get_second_part() const { return second_part; }
   inline void set_second_part(uint32_t new_second_part) { second_part = new_second_part; }
 
   /**

=== modified file 'drizzled/thr_lock.cc'
--- drizzled/thr_lock.cc	2011-04-13 12:17:56 +0000
+++ drizzled/thr_lock.cc	2011-08-07 22:41:28 +0000
@@ -82,8 +82,7 @@
 
 using namespace std;
 
-namespace drizzled
-{
+namespace drizzled {
 
 uint64_t table_lock_wait_timeout;
 static enum thr_lock_type thr_upgraded_concurrent_insert_lock = TL_WRITE;
@@ -106,7 +105,6 @@
 
 void thr_lock_init(THR_LOCK *lock)
 {
-  lock->init();
   lock->read.last= &lock->read.data;
   lock->read_wait.last= &lock->read_wait.data;
   lock->write_wait.last= &lock->write_wait.data;
@@ -612,7 +610,6 @@
     if ((*pos)->type != TL_UNLOCK)
       thr_unlock(*pos);
   }
-  return;
 }
 
 void DrizzleLock::unlock(uint32_t count)

=== modified file 'drizzled/thr_lock.h'
--- drizzled/thr_lock.h	2011-03-28 23:48:44 +0000
+++ drizzled/thr_lock.h	2011-08-07 22:41:28 +0000
@@ -23,8 +23,7 @@
 
 #include <drizzled/visibility.h>
 
-namespace drizzled
-{
+namespace drizzled {
 
 extern uint64_t max_write_lock_count;
 extern uint64_t table_lock_wait_timeout;
@@ -153,9 +152,6 @@
     read_no_write_count(0)
   { }
 
-  ~THR_LOCK()
-  { }
-
   void abort_locks();
   bool abort_locks_for_thread(uint64_t thread);
 
@@ -169,14 +165,6 @@
     mutex.unlock();
   }
 
-  void init()
-  {
-  }
-
-  void deinit()
-  {
-  }
-
   boost::mutex *native_handle()
   {
     return &mutex;

=== modified file 'drizzled/type/decimal.cc'
--- drizzled/type/decimal.cc	2011-06-22 20:05:58 +0000
+++ drizzled/type/decimal.cc	2011-08-08 09:51:16 +0000
@@ -2669,17 +2669,17 @@
 void test_d2b2d(const char *str, int p, int s, const char *orig, int ex)
 {
   char s1[100], buf[100], *end;
-  int res, i, size=decimal_bin_size(p, s);
+  int size=decimal_bin_size(p, s);
 
   snprintf(s1, sizeof(s1), "'%s'", str);
   end= strend(str);
   string2decimal(str, &a, &end);
-  res=decimal2bin(&a, buf, p, s);
+  int res=decimal2bin(&a, buf, p, s);
   printf("%-31s {%2d, %2d} => res=%d size=%-2d ", s1, p, s, res, size);
   if (full)
   {
     printf("0x");
-    for (i=0; i < size; i++)
+    for (int i= 0; i < size; i++)
       printf("%02x", ((unsigned char *)buf)[i]);
   }
   res=bin2decimal(buf, &a, p, s);

=== modified file 'drizzled/type/uuid.h'
--- drizzled/type/uuid.h	2011-07-25 04:35:53 +0000
+++ drizzled/type/uuid.h	2011-08-08 09:51:16 +0000
@@ -67,12 +67,11 @@
 #include <cstdio>
 #include <iosfwd>
 
-namespace drizzled
-{
-namespace type
-{
+namespace drizzled {
+namespace type {
 
-class Uuid {
+class Uuid 
+{
 	uint32_t	time_low;
 	uint16_t	time_mid;
 	uint16_t	time_hi_and_version;
@@ -188,7 +187,7 @@
     return false;
   }
 
-  void unparse(char *out)
+  void unparse(char *out) const
   {
     snprintf(out, DISPLAY_BUFFER_LENGTH, "%08x-%04x-%04x-%02x%02x-%02x%02x%02x%02x%02x%02x",
             time_low,
@@ -204,7 +203,7 @@
             node[5]);
   }
 
-  void time(struct timeval& ret_val)
+  void time(timeval& ret_val) const
   {
     uint32_t high;
     uint64_t clock_reg;
@@ -216,9 +215,9 @@
     ret_val.tv_sec = clock_reg / 10000000;
     ret_val.tv_usec = (clock_reg % 10000000) / 10;
   }
-  bool isTimeType()
+  bool isTimeType() const
   {
-    return ((time_hi_and_version >> 12) & 0xF) == 1 ? true : false; 
+    return ((time_hi_and_version >> 12) & 0xF) == 1; 
   }
 
   static const size_t LENGTH= 16;

=== modified file 'drizzled/util/data_ref.h'
--- drizzled/util/data_ref.h	2011-08-05 12:55:59 +0000
+++ drizzled/util/data_ref.h	2011-08-08 16:50:37 +0000
@@ -53,10 +53,11 @@
     assign(b, strlen(b));
   }
 
-  void clear()
+  const data_ref_basic& clear()
   {
     begin_ = NULL;
     end_ = NULL;
+    return *this;
   }
 
   void assign(const void* b, const void* e)

=== modified file 'plugin/innobase/handler/ha_innodb.cc'
--- plugin/innobase/handler/ha_innodb.cc	2011-07-30 09:20:56 +0000
+++ plugin/innobase/handler/ha_innodb.cc	2011-08-11 09:18:19 +0000
@@ -6957,7 +6957,7 @@
 
   ut_a(prebuilt->trx == session_to_trx(getTable()->in_use));
 
-  prebuilt->trx->op_info = (char*)"estimating records in index range";
+  prebuilt->trx->op_info = "estimating records in index range";
 
   /* In case MySQL calls this in the middle of a SELECT query, release
   possible adaptive hash latch to avoid deadlocks of threads */
@@ -7029,7 +7029,7 @@
 func_exit:
   free(key_val_buff2);
 
-  prebuilt->trx->op_info = (char*)"";
+  prebuilt->trx->op_info = "";
 
   /* The MySQL optimizer seems to believe an estimate of 0 rows is
   always accurate and may return the result 'Empty set' based on that.
@@ -7090,7 +7090,7 @@
   estimate = 2 * local_data_file_length /
            dict_index_calc_min_rec_len(index);
 
-  prebuilt->trx->op_info = (char*)"";
+  prebuilt->trx->op_info = "";
 
   return((ha_rows) estimate);
 }
@@ -7280,7 +7280,7 @@
   /* In case MySQL calls this in the middle of a SELECT query, release
   possible adaptive hash latch to avoid deadlocks of threads */
 
-  prebuilt->trx->op_info = (char*)"returning various info to MySQL";
+  prebuilt->trx->op_info = "returning various info to MySQL";
 
   trx_search_latch_release_if_reserved(prebuilt->trx);
 
@@ -7527,7 +7527,7 @@
   }
 
 func_exit:
-  prebuilt->trx->op_info = (char*)"";
+  prebuilt->trx->op_info = "";
 
   return(0);
 }
@@ -7738,7 +7738,7 @@
 
   update_session(getTable()->in_use);
 
-  prebuilt->trx->op_info = (char*)"returning table comment";
+  prebuilt->trx->op_info = "returning table comment";
 
   /* In case MySQL calls this in the middle of a SELECT query, release
   possible adaptive hash latch to avoid deadlocks of threads */
@@ -7783,7 +7783,7 @@
 
   mutex_exit(&srv_dict_tmpfile_mutex);
 
-  prebuilt->trx->op_info = (char*)"";
+  prebuilt->trx->op_info = "";
 
   return(str ? str : (char*) comment);
 }
@@ -7809,7 +7809,7 @@
 
   update_session(getTable()->in_use);
 
-  prebuilt->trx->op_info = (char*)"getting info on foreign keys";
+  prebuilt->trx->op_info = "getting info on foreign keys";
 
   /* In case MySQL calls this in the middle of a SELECT query,
   release possible adaptive hash latch to avoid
@@ -7823,7 +7823,7 @@
   /* output the data to a temporary file */
   dict_print_info_on_foreign_keys(TRUE, srv_dict_tmpfile,
         prebuilt->trx, prebuilt->table);
-  prebuilt->trx->op_info = (char*)"";
+  prebuilt->trx->op_info = "";
 
   flen = ftell(srv_dict_tmpfile);
   if (flen < 0) {
@@ -7851,19 +7851,15 @@
 int
 ha_innobase::get_foreign_key_list(Session *session, List<ForeignKeyInfo> *f_key_list)
 {
-  dict_foreign_t* foreign;
-
   ut_a(prebuilt != NULL);
   update_session(getTable()->in_use);
-  prebuilt->trx->op_info = (char*)"getting list of foreign keys";
+  prebuilt->trx->op_info = "getting list of foreign keys";
   trx_search_latch_release_if_reserved(prebuilt->trx);
   mutex_enter(&(dict_sys->mutex));
-  foreign = UT_LIST_GET_FIRST(prebuilt->table->foreign_list);
+  dict_foreign_t* foreign = UT_LIST_GET_FIRST(prebuilt->table->foreign_list);
 
   while (foreign != NULL) {
 
-    uint i;
-    lex_string_t *name = 0;
     uint ulen;
     char uname[NAME_LEN + 1];           /* Unencoded name */
     char db_name[NAME_LEN + 1];
@@ -7871,11 +7867,11 @@
 
     /** Foreign id **/
     tmp_buff = foreign->id;
-    i = 0;
+    uint i = 0;
     while (tmp_buff[i] != '/')
       i++;
     tmp_buff += i + 1;
-    lex_string_t *tmp_foreign_id = session->make_lex_string(NULL, tmp_buff, strlen(tmp_buff), true);
+    lex_string_t *tmp_foreign_id = session->make_lex_string(NULL, str_ref(tmp_buff));
 
     /* Database name */
     tmp_buff = foreign->referenced_table_name;
@@ -7888,23 +7884,20 @@
     }
     db_name[i] = 0;
     ulen= identifier::Table::filename_to_tablename(db_name, uname, sizeof(uname));
-    lex_string_t *tmp_referenced_db = session->make_lex_string(NULL, uname, ulen, true);
+    lex_string_t *tmp_referenced_db = session->make_lex_string(NULL, str_ref(uname, ulen));
 
     /* Table name */
     tmp_buff += i + 1;
     ulen= identifier::Table::filename_to_tablename(tmp_buff, uname, sizeof(uname));
-    lex_string_t *tmp_referenced_table = session->make_lex_string(NULL, uname, ulen, true);
+    lex_string_t *tmp_referenced_table = session->make_lex_string(NULL, str_ref(uname, ulen));
 
     /** Foreign Fields **/
     List<lex_string_t> tmp_foreign_fields;
     List<lex_string_t> tmp_referenced_fields;
-    for (i= 0;;) {
-      tmp_buff= foreign->foreign_col_names[i];
-      name = session->make_lex_string(name, tmp_buff, strlen(tmp_buff), true);
-      tmp_foreign_fields.push_back(name);
-      tmp_buff= foreign->referenced_col_names[i];
-      name = session->make_lex_string(name, tmp_buff, strlen(tmp_buff), true);
-      tmp_referenced_fields.push_back(name);
+    for (i= 0;;) 
+		{
+      tmp_foreign_fields.push_back(session->make_lex_string(NULL, str_ref(foreign->foreign_col_names[i])));
+      tmp_referenced_fields.push_back(session->make_lex_string(NULL, str_ref(foreign->referenced_col_names[i])));
       if (++i >= foreign->n_fields)
         break;
     }
@@ -7930,7 +7923,7 @@
       length=8;
       tmp_buff= "RESTRICT";
     }
-    lex_string_t *tmp_delete_method = session->make_lex_string(NULL, tmp_buff, length, true);
+    lex_string_t *tmp_delete_method = session->make_lex_string(NULL, str_ref(tmp_buff, length));
 
 
     if (foreign->type & DICT_FOREIGN_ON_UPDATE_CASCADE)
@@ -7953,15 +7946,13 @@
       length=8;
       tmp_buff= "RESTRICT";
     }
-    lex_string_t *tmp_update_method = session->make_lex_string(NULL, tmp_buff, length, true);
+    lex_string_t *tmp_update_method = session->make_lex_string(NULL, str_ref(tmp_buff, length));
 
     lex_string_t *tmp_referenced_key_name = NULL;
 
-    if (foreign->referenced_index &&
-        foreign->referenced_index->name)
+    if (foreign->referenced_index && foreign->referenced_index->name)
     {
-      tmp_referenced_key_name = session->make_lex_string(NULL,
-                                                         foreign->referenced_index->name, strlen(foreign->referenced_index->name), true);
+      tmp_referenced_key_name = session->make_lex_string(NULL, str_ref(foreign->referenced_index->name));
     }
 
     ForeignKeyInfo f_key_info(
@@ -7969,12 +7960,11 @@
                               tmp_update_method, tmp_delete_method, tmp_referenced_key_name,
                               tmp_foreign_fields, tmp_referenced_fields);
 
-    ForeignKeyInfo *pf_key_info = (ForeignKeyInfo*)session->mem.memdup(&f_key_info, sizeof(ForeignKeyInfo));
-    f_key_list->push_back(pf_key_info);
+    f_key_list->push_back((ForeignKeyInfo*)session->mem.memdup(&f_key_info, sizeof(ForeignKeyInfo)));
     foreign = UT_LIST_GET_NEXT(foreign_list, foreign);
   }
   mutex_exit(&(dict_sys->mutex));
-  prebuilt->trx->op_info = (char*)"";
+  prebuilt->trx->op_info = "";
 
   return(0);
 }
@@ -8549,7 +8539,6 @@
 
     HASH_DELETE(INNOBASE_SHARE, table_name_hash,
           innobase_open_tables, fold, share);
-    share->lock.deinit();
 
     /* Free any memory from index translation table */
     free(share->idx_trans_tbl.index_mapping);

=== modified file 'plugin/memory/ha_heap.cc'
--- plugin/memory/ha_heap.cc	2011-07-15 08:26:31 +0000
+++ plugin/memory/ha_heap.cc	2011-08-08 12:51:19 +0000
@@ -621,12 +621,12 @@
    [2  non-unique indexes are disabled - NOT YET IMPLEMENTED]
 */
 
-int ha_heap::indexes_are_disabled(void)
+int ha_heap::indexes_are_disabled()
 {
   return heap_indexes_are_disabled(file);
 }
 
-void ha_heap::drop_table(const char *)
+void ha_heap::drop_table()
 {
   file->getShare()->delete_on_close= 1;
   close();

=== modified file 'plugin/memory/ha_heap.h'
--- plugin/memory/ha_heap.h	2011-03-14 05:40:28 +0000
+++ plugin/memory/ha_heap.h	2011-08-08 12:51:19 +0000
@@ -83,7 +83,7 @@
   drizzled::ha_rows records_in_range(uint32_t inx,
                                      drizzled::key_range *min_key,
                                      drizzled::key_range *max_key);
-  void drop_table(const char *name);
+  void drop_table();
 
   int cmp_ref(const unsigned char *ref1, const unsigned char *ref2);
   int reset_auto_increment(uint64_t value)

=== modified file 'plugin/mysql_protocol/mysql_protocol.cc'
--- plugin/mysql_protocol/mysql_protocol.cc	2011-06-13 14:33:05 +0000
+++ plugin/mysql_protocol/mysql_protocol.cc	2011-08-10 16:48:48 +0000
@@ -70,12 +70,12 @@
   counters.push_back(new drizzled::plugin::ListenCounter(new std::string("failed_connections"), &getCounters().failedConnections));
 }
 
-const std::string ListenMySQLProtocol::getHost(void) const
+const std::string ListenMySQLProtocol::getHost() const
 {
   return _hostname;
 }
 
-in_port_t ListenMySQLProtocol::getPort(void) const
+in_port_t ListenMySQLProtocol::getPort() const
 {
   return port.get();
 }
@@ -219,7 +219,7 @@
   if (packet_length == 0)                       /* safety */
   {
     /* Initialize with COM_SLEEP packet */
-    (*l_packet)[0]= (unsigned char) COM_SLEEP;
+    (*l_packet)[0]= COM_SLEEP;
     packet_length= 1;
   }
   else
@@ -258,8 +258,7 @@
 #ifdef NEVER
   /* See comment above. */
   /* Restore read timeout value */
-  drizzleclient_net_set_read_timeout(&net,
-                                     session->variables.net_read_timeout);
+  drizzleclient_net_set_read_timeout(&net, session->variables.net_read_timeout);
 #endif
 
   return true;
@@ -369,11 +368,8 @@
 
 void ClientMySQLProtocol::sendError(drizzled::error_t sql_errno, const char *err)
 {
-  uint32_t length;
-  /*
-    buff[]: sql_errno:2 + ('#':1 + SQLSTATE_LENGTH:5) + DRIZZLE_ERRMSG_SIZE:512
-  */
-  unsigned char buff[2+1+SQLSTATE_LENGTH+DRIZZLE_ERRMSG_SIZE], *pos;
+  // buff[]: sql_errno:2 + ('#':1 + SQLSTATE_LENGTH:5) + DRIZZLE_ERRMSG_SIZE:512
+  unsigned char buff[2 + 1 + SQLSTATE_LENGTH + DRIZZLE_ERRMSG_SIZE];
 
   assert(sql_errno != EE_OK);
   assert(err && err[0]);
@@ -401,19 +397,16 @@
   }
 
   int2store(buff, static_cast<uint16_t>(sql_errno));
-  pos= buff+2;
 
   /* The first # is to make the client backward compatible */
   buff[2]= '#';
-  pos= (unsigned char*) strcpy((char*) buff+3, error::convert_to_sqlstate(sql_errno));
+  unsigned char* pos= (unsigned char*) strcpy((char*) buff+3, error::convert_to_sqlstate(sql_errno));
   pos+= strlen(error::convert_to_sqlstate(sql_errno));
 
   char *tmp= strncpy((char*)pos, err, DRIZZLE_ERRMSG_SIZE-1);
   tmp+= strlen((char*)pos);
   tmp[0]= '\0';
-  length= (uint32_t)(tmp-(char*)buff);
-  err= (char*) buff;
-  net.write_command((unsigned char) 255, (unsigned char*) "", 0, (unsigned char*) err, length);
+  net.write_command(255, data_ref().clear(), data_ref(buff, tmp));
   net.flush();
   session->main_da().can_overwrite_status= false;
 }
@@ -585,25 +578,25 @@
 void ClientMySQLProtocol::store(int32_t from)
 {
   char buff[12];
-  netStoreData(buff, (internal::int10_to_str(from, buff, -10) - buff));
+  netStoreData(buff, internal::int10_to_str(from, buff, -10) - buff);
 }
 
 void ClientMySQLProtocol::store(uint32_t from)
 {
   char buff[11];
-  netStoreData(buff, (size_t) (internal::int10_to_str(from, buff, 10) - buff));
+  netStoreData(buff, internal::int10_to_str(from, buff, 10) - buff);
 }
 
 void ClientMySQLProtocol::store(int64_t from)
 {
   char buff[22];
-  netStoreData(buff, (size_t) (internal::int64_t10_to_str(from, buff, -10) - buff));
+  netStoreData(buff, internal::int64_t10_to_str(from, buff, -10) - buff);
 }
 
 void ClientMySQLProtocol::store(uint64_t from)
 {
   char buff[21];
-  netStoreData(buff, (size_t) (internal::int64_t10_to_str(from, buff, 10) - buff));
+  netStoreData(buff, internal::int64_t10_to_str(from, buff, 10) - buff);
 }
 
 void ClientMySQLProtocol::store(double from, uint32_t decimals, String *buffer)
@@ -690,13 +683,8 @@
     *end++= 0; /* an empty byte for some reason */
 
     /* At this point we write connection message and read reply */
-    if (net.write_command(
-            (unsigned char) PROTOCOL_VERSION
-          , (unsigned char*) ""
-          , 0
-          , (unsigned char*) buff
-          , (size_t) (end-buff)) 
-        ||    (pkt_len= net.read()) == packet_error 
+    if (net.write_command(PROTOCOL_VERSION, data_ref().clear(), data_ref(buff, end)) 
+        || (pkt_len= net.read()) == packet_error 
         || pkt_len < MIN_HANDSHAKE_SIZE)
     {
       my_error(ER_HANDSHAKE_ERROR, MYF(0), user_identifier->address().c_str());
@@ -706,7 +694,7 @@
   packet.alloc(buffer_length.get());
 
   client_capabilities= uint2korr(net.read_pos);
-  if (!(client_capabilities & CLIENT_PROTOCOL_MYSQL41))
+  if (not (client_capabilities & CLIENT_PROTOCOL_MYSQL41))
   {
     my_error(ER_HANDSHAKE_ERROR, MYF(0), user_identifier->address().c_str());
     return false;
@@ -822,8 +810,7 @@
   write it to the network output buffer.
 */
 
-void ClientMySQLProtocol::writeEOFPacket(uint32_t server_status,
-                                         uint32_t total_warn_count)
+void ClientMySQLProtocol::writeEOFPacket(uint32_t server_status, uint32_t total_warn_count)
 {
   unsigned char buff[5];
   /*
@@ -859,26 +846,26 @@
 
 unsigned char *ClientMySQLProtocol::storeLength(unsigned char *buffer, uint64_t length)
 {
-  if (length < (uint64_t) 251LL)
+  if (length < 251)
   {
-    *buffer=(unsigned char) length;
+    *buffer= (unsigned char) length;
     return buffer+1;
   }
   /* 251 is reserved for NULL */
-  if (length < (uint64_t) 65536LL)
+  if (length < 65536)
   {
-    *buffer++=252;
-    int2store(buffer,(uint32_t) length);
+    *buffer++= 252;
+    int2store(buffer, (uint32_t) length);
     return buffer+2;
   }
-  if (length < (uint64_t) 16777216LL)
+  if (length < 16777216)
   {
     *buffer++=253;
-    int3store(buffer,(uint32_t) length);
+    int3store(buffer, (uint32_t) length);
     return buffer+3;
   }
   *buffer++=254;
-  int8store(buffer,length);
+  int8store(buffer, length);
   return buffer+8;
 }
 

=== modified file 'plugin/mysql_protocol/net_serv.cc'
--- plugin/mysql_protocol/net_serv.cc	2011-06-09 16:38:31 +0000
+++ plugin/mysql_protocol/net_serv.cc	2011-08-08 16:50:37 +0000
@@ -751,11 +751,9 @@
   return drizzleclient_net_write(this, data, size);
 }
 
-bool NET::write_command(unsigned char command,
-  const unsigned char *header, size_t head_len,
-  const unsigned char *packet, size_t len)
+bool NET::write_command(unsigned char command, data_ref header, data_ref body)
 {
-  return drizzleclient_net_write_command(this, command, header, head_len, packet, len);
+  return drizzleclient_net_write_command(this, command, header.data(), header.size(), body.data(), body.size());
 }
 
 uint32_t NET::read()

=== modified file 'plugin/mysql_protocol/net_serv.h'
--- plugin/mysql_protocol/net_serv.h	2011-06-09 16:38:31 +0000
+++ plugin/mysql_protocol/net_serv.h	2011-08-08 16:50:37 +0000
@@ -53,9 +53,7 @@
   void set_write_timeout(uint32_t timeout);
   void set_read_timeout(uint32_t timeout);
   bool write(const void*, size_t);
-  bool write_command(unsigned char command,
-    const unsigned char *header, size_t head_len,
-    const unsigned char *packet, size_t len);
+  bool write_command(unsigned char command, data_ref header, data_ref body);
   uint32_t read();
 };
 

=== modified file 'plugin/pbms/src/ha_pbms.h'
--- plugin/pbms/src/ha_pbms.h	2011-03-14 05:40:28 +0000
+++ plugin/pbms/src/ha_pbms.h	2011-08-11 16:18:02 +0000
@@ -95,7 +95,7 @@
 	uint	max_supported_key_part_length() const { return 1024; }
 
 	int open(const char *name, int mode, uint test_if_locked);
-	void drop_table(const char *name) {UNUSED(name);}
+	void drop_table() {}
 
 	int close(void);
 #ifdef DRIZZLED

=== modified file 'plugin/pbms/src/system_table_ms.cc'
--- plugin/pbms/src/system_table_ms.cc	2011-07-25 04:35:53 +0000
+++ plugin/pbms/src/system_table_ms.cc	2011-08-11 16:18:02 +0000
@@ -2390,9 +2390,7 @@
 
 MSSystemTableShare::~MSSystemTableShare()
 {
-#ifdef DRIZZLED
-	myThrLock.deinit();
-#else
+#ifndef DRIZZLED
 	thr_lock_delete(&myThrLock);
 #endif
 	if (myTablePath) {

=== modified file 'plugin/regex_policy/policy.h'
--- plugin/regex_policy/policy.h	2011-07-25 04:35:53 +0000
+++ plugin/regex_policy/policy.h	2011-08-08 09:51:16 +0000
@@ -139,7 +139,7 @@
 
 inline bool PolicyItem::isRestricted()
 {
-  return action == POLICY_DENY ? true : false;
+  return action == POLICY_DENY;
 }
 
 void clearPolicyItemList(PolicyItemList policies);

=== modified file 'plugin/utility_functions/execute.cc'
--- plugin/utility_functions/execute.cc	2011-04-13 12:46:37 +0000
+++ plugin/utility_functions/execute.cc	2011-08-10 17:58:23 +0000
@@ -30,17 +30,13 @@
 bool Execute::val_bool()
 {
   drizzled::String *res= args[0]->val_str(&_res);
-
   if (not res or not res->length())
   {
     null_value= true;
     return false;
   }
-
-  execute.run(res->c_str(), res->length());
-
+  execute.run(*res);
   null_value= false;
-
   return true;
 }
 

